GNU bug report logs - #55645
src/print.c; print_object changes make it impossible to compare elisp code across versions

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Tom Gillespie <tgbugs@HIDDEN>; Keywords: moreinfo; dated Wed, 25 May 2022 23:13:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 7 Jun 2022 16:35:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 07 12:35:56 2022
Received: from localhost ([127.0.0.1]:41280 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nycBH-0006gL-59
	for submit <at> debbugs.gnu.org; Tue, 07 Jun 2022 12:35:56 -0400
Received: from eggs.gnu.org ([209.51.188.92]:46456)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1nycBC-0006fw-9H
 for 55645 <at> debbugs.gnu.org; Tue, 07 Jun 2022 12:35:45 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:40676)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1nycB6-0001UP-Il; Tue, 07 Jun 2022 12:35:36 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=7WNPCu8I3n36CFW3xscI0nDU34qSzoIom8XxEOWSjT4=; b=Ke39RU7usqLj
 V50DAV3wVZujYVYsPkTLVSlgZ1YW5ZFYMJ3VKdXUAvwnGT2wcrPrWgr5d5bMLOHUc8juya4ROcUCl
 o2Liz/ZIDYYDQZeItZd6vF7hWvGRqmvL86fzlgMPoQofWPruvLMwYXpoRq5a5uvkbYDMwIPZX5lSY
 CLed2CH08t6ED1R1dNubUcdGveQ80wLVrOhy7yd4FgKkKwqsGcc88QncfAZ9NUaeFV90SgOLiFfcv
 vXo4B0PSTwVYrYSaUvAqPmSoQtifYc6kGi4c6s64MwNhZS51Dl/L1vva1/72Nc3pdnND7kyFXuP8U
 UTvcgHyVY3MW4cYba4F5oA==;
Received: from [87.69.77.57] (port=4260 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1nycAi-0002Ub-VW; Tue, 07 Jun 2022 12:35:31 -0400
Date: Tue, 07 Jun 2022 19:35:05 +0300
Message-Id: <83zgio5t52.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Tom Gillespie <tgbugs@HIDDEN>
In-Reply-To: <CA+G3_PNpPUSff5Xvdg1sOCk+EGU8M9LFS2_a6W4Ft_tFGwZByg@HIDDEN>
 (message from Tom Gillespie on Mon, 6 Jun 2022 16:30:22 -0700)
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 <83czfobxht.fsf@HIDDEN>
 <CA+G3_PNpPUSff5Xvdg1sOCk+EGU8M9LFS2_a6W4Ft_tFGwZByg@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: larsi@HIDDEN, 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Tom Gillespie <tgbugs@HIDDEN>
> Date: Mon, 6 Jun 2022 16:30:22 -0700
> Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 55645 <at> debbugs.gnu.org
> 
> > Thus, I agree with Lars that it is strange to hear that prin1 is used
> > as something that's supposed to produce a canonical representation of
> > Lisp code; it's definitely isn't its purpose.
> 
> Am I wrong in my assumption about pp-buffer and read?

Of course you are wrong, since we changed prin1 without affecting
read.  We could also change both prin1 and read such that what the
former produces the latter can consume, as long as the "usual" Lisp
code can still be read without any problem.

> I mean, yes in principle prin1 could start escaping every single
> character in every symbol since it will ultimately read in the same
> way, but that seems somewhat unlikely.

Unlikely for every character, but we could decide to do that for a few
special ones, for example.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 6 Jun 2022 23:30:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 06 19:30:44 2022
Received: from localhost ([127.0.0.1]:37085 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nyMBI-0001hf-BZ
	for submit <at> debbugs.gnu.org; Mon, 06 Jun 2022 19:30:44 -0400
Received: from mail-yb1-f181.google.com ([209.85.219.181]:37569)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <tgbugs@HIDDEN>) id 1nyMBC-0001hO-Sg
 for 55645 <at> debbugs.gnu.org; Mon, 06 Jun 2022 19:30:42 -0400
Received: by mail-yb1-f181.google.com with SMTP id v15so389791ybe.4
 for <55645 <at> debbugs.gnu.org>; Mon, 06 Jun 2022 16:30:38 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=lw9thhmuX44WuQYRKrWRhVAfebcYMYR4gX9q7KNf3X8=;
 b=lIZWgzSutcPaAdFb5UtVcoTneGSMImCgC2io5ISFzym4feVxcFgnpgmbI0r4X3He3w
 Ck86arM3xsyg2g4Cu11AJmnS+d+KC4m3ZNnQ7JnlW/F53ahtAkOMnC2wrIZ0V4LzVBJf
 DT8BkGufgRjcZpgumBY9EYAmBV8cdctJdfYvN4gA6NCwwGELN7o1FuboN/c7QvazM0TS
 XlWdoBrdFnCOfN2sfjIamiLHffDKwImNt5aU2+3TRRGg+R6qflg40QmdpOvjoB4UM6tq
 WGpKMHVUXO/0nTrB9h17601beX1J5zGnU7wNL8+2mRUcokk6Yuk49wdKEOHioCOHlmne
 cfIw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=lw9thhmuX44WuQYRKrWRhVAfebcYMYR4gX9q7KNf3X8=;
 b=qPWDVC+Hf6B/GkZmC7KYVCCj5Sdh6mQqFAIocgaBm0Z56w+874tW4btrXeGhbY2oIB
 P3bzMJPIYucqF+vPGCYtGPlnzUmO+p/kd5rvxfnqvDTXrIiZAbQpMnH5XrowKQWRk9pU
 i0aVfVQxi1Pd71TvcwD9UEh0blxuupvW6hT/TaV69FjAN3unTZp/vkSF4fhg78nyh5vP
 TJBoGGveTavD/E/diviRGufP3Sa0pQsdURe9ach4MatMibXC7mMZ7jFJlvwycd4tnr2E
 +mYlf/kc1QZhe3/PuLSWasgXwqJkWGGrLBiXjiJsBWyP2NdRewxHCpaLgcD5Kwivs3eZ
 HGgA==
X-Gm-Message-State: AOAM531upgWv+qDR+7CspCHI2lNj5WyeEhD6XScO2nHijg9ozTzZtsfa
 NKlR8+sreLSVk2cAmub6Wt5D5Lv8DU5z8dn+WpA=
X-Google-Smtp-Source: ABdhPJyKmBhzRqRHcbQUobxJG+HvbzmAeMlYI+ftAvj3spaDpJNHY4/qOqdjjLq2pCyxfjYt5zpdk6xLfPSBKiNkubg=
X-Received: by 2002:a25:d906:0:b0:663:aa8e:b379 with SMTP id
 q6-20020a25d906000000b00663aa8eb379mr5798300ybg.455.1654558233267; Mon, 06
 Jun 2022 16:30:33 -0700 (PDT)
MIME-Version: 1.0
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 <83czfobxht.fsf@HIDDEN>
In-Reply-To: <83czfobxht.fsf@HIDDEN>
From: Tom Gillespie <tgbugs@HIDDEN>
Date: Mon, 6 Jun 2022 16:30:22 -0700
Message-ID: <CA+G3_PNpPUSff5Xvdg1sOCk+EGU8M9LFS2_a6W4Ft_tFGwZByg@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 55645
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Eli,
   Replies in line. Best!
Tom

> You say in your OP that there's no way to work around the issue, but I
> wonder if this is really so.  It seems to me that by adding a
> backslash before '.' and '?', before computing the hash, would be one
> workaround?

Unfortunately I don't think there is an easy way to do such a thing
from elisp. The primary issue with such a workaround is that while
it is safe to do that inside strings and symbols, you have to know
the type of the object that is being printed, otherwise floats and
characters will be inadvertently converted to symbols.

As far as I can tell the only place to make such a change is inside
the c implementation of prin1 or some other c function, thus my request
for a dynamic variable that would preserve the old behavior by allowing
me to reach into the c runtime.

> Frankly, I'm amazed that someone could have such faith into
> immutability of Emacs Lisp.  Why would you assume that the above
> produces the same literal string across versions, especially given
> everything that happens lately in Emacs, including changes in the
> byte-compiler, the introduction of native-compilation, etc.

I wouldn't call it faith so much as testing, and perhaps an assumption
that there wasn't any reason to change something so fundamental
that affected so few people and had been stable for so long.

Also, it does not seem such an unfounded assumption because for code
the prin1 representation (or at least the pp-buffer representation) must
produce valid elisp that can be read, and the reader is extremely stable.
In particular the representation also ideally needs to be read by older
versions of emacs because some libraries would like to be able to
support multiple versions of emacs with a single.el file.

As I note below the particular relaxation in the behavior of the reader
was made long ago, the change in the prin1 behavior only affects very
old versions of emacs, though emacs-18 is installable and usable on
gentoo, I have no idea whether anyone actually shares code between
emacs-18 and emacs-29, so that is likely a moot point.

> If someone would show me a design that is based on this, I'd tell them
> they place their bet on a dubious horse, and suggest to find a better
> design.  To me, this is taking some Emacs feature that just happened
> to be stable, and assuming it will forever be stable.  There's no
> reason and no real basis for such assumptions.

As mentioned above, there is a strong basis for such assumptions,
which is that prin1 or at least pp-buffer must produce valid elisp code
that can be read.

Thus the stability of prin1 is intrinsically tied to what the reader
will accept. So the change that we are discussing here is due to
the fact that there was a change in the reader to relax what it would
accept with regard to '.' and '?' in symbols.

>
> Thus, I agree with Lars that it is strange to hear that prin1 is used
> as something that's supposed to produce a canonical representation of
> Lisp code; it's definitely isn't its purpose.

Am I wrong in my assumption about pp-buffer and read? I mean, yes
in principle prin1 could start escaping every single character in every
symbol since it will ultimately read in the same way, but that seems
somewhat unlikely.

> Anyway, one way forward is to add a new API specifically for that
> purpose, and then guarantee that the output of that new API will be
> stable.  This will also take care of the issue with the design that
> relies on prin1.

This seems like the "right" solution long term. It allows us to skip
the aesthetics discussion going on at the moment, and it provides
an explicitly stable representation for readable forms, allowing prin1
to be free of any such constraints (complaints?) in the future.
It would be possible to use fboundp to check whether the new stable
prin1 was present and use that going forward, if it is not found then
prin1 itself should be fine through 28. This seems preferable to having
an implicit subset of readable objects that are mostly stable in prin1
but can sometimes change to match current reader behavior.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 4 Jun 2022 13:48:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 04 09:48:15 2022
Received: from localhost ([127.0.0.1]:57928 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nxU8V-0007yG-Kk
	for submit <at> debbugs.gnu.org; Sat, 04 Jun 2022 09:48:15 -0400
Received: from sonic308-56.consmr.mail.ne1.yahoo.com ([66.163.187.31]:39837)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <luangruo@HIDDEN>) id 1nxU8T-0007y2-1A
 for 55645 <at> debbugs.gnu.org; Sat, 04 Jun 2022 09:48:13 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yahoo.com; s=s2048;
 t=1654350487; bh=VlLbHjhWa90CNKenUFQVt0FD1Vl5LgNXxefd0K12EvI=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From:Subject:Reply-To;
 b=gHFja7gNbAR30GDr5bdhaegp/S0YHg0Vi7ABZsCMu7Q20W+aq0RfmqeIUwQeJ4xFNXfQJqw5ph9Pvr/8rWEqErAiHuzhm021fwdNOYoeyh/grQ8FwJQ95YcFDPQOaVoR6R5d7RM7qRRjUB+p8ZFQQ2AZNgpV2Wpv9CMD1LUzI6YyyrofzxEW8bxnUz578kUFnSPl2e+PXT5IxCYY1W1oOByoZ0UVRyErpMG+jeelbjIT5eJmC+vgMfN667Ua8f35P0qI7f+Lm9god7rlXloSz78AJa3HDiB5opBv9V8zsvIvOTF5XzEybn71MCXs+yVwM6AWr2RP7HexBGLmua+n7Q==
X-SONIC-DKIM-SIGN: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yahoo.com; s=s2048;
 t=1654350487; bh=Btw9Z4XLZF1goxI4trJ1y0ecyL6J+JSphyYEOVB/zqA=;
 h=X-Sonic-MF:From:To:Subject:Date:From:Subject;
 b=iz5g+mpdHr/d32hw7D3icuwlmgIQLi2HHqbQTccJiKGaJv3O25cSfFWQAcCY6zWmGz2Af3gICDBgwNbn3c7fon9Om54oCfyi+d0Ix2kSNZCGxV/sL0D6LeP/ICt/d9x4L39BKUFYfk5EvbkDkxRbtOAD7uTsWDS5MeFmtxOWiw5o0EnoMQWm2Rzq679MlB3WZ4dOFAYAO1BZOxr30jgcFYBXBVRo4s+uhdTJ3seatFu9F2McaWA5qeB/2v0UFJy77S5wbOps3BG9BTHKqQlwjAluGmIILJtih0+f8P3xckYmkium5VXCZWwNQrv5oRKouHHHw/U/vcFv7gmZn8Eymg==
X-YMail-OSG: 1xY7lUAVM1l9aM2jGac8K0Ly0R86aE9gVeNVktN3.QrGj6PN9uNpkm2W8XyVA7W
 Y.o3CKotQ1k6O_WTtdB9BfDcZjo6yiD6yompc5LEAtEZzxvYMomcR9R2bkYpMAqtQTOj720I6DjA
 RsXDXIq82l1HRGd1NDJC.vUSW_G42fVn76x9bR7Zc6lQk0zkNXhToF13F.fmc.paUjGO04rRLirI
 8OpWXtCSJCgNLeGXeVBavyeac09FSgFFpQLPvaS8VpqIb.wfPw1CR7CR8KOhoQEm5HmwOJYFO1Np
 dlwimRR0bMpSQIhs56R6Z1_AM9E8JHK10_MAN1mg9kxPTXwAIRXtvKnT.DqEtD.4yyqa3MadNqlV
 YReizhSY644lAGBx04xsCuck138MjKgRH7FhE9GDjVcYntxMBZ.hS5hPyEGbqadD7m.VrsNg8gQD
 yumKid_XFrwcL2RcbA66pKhrfEcQW7uJbT.QeI1Tdbzzns0yWIjhN4c1CdZhhXl7QFSWLaqzD2GL
 6d8pCZIl8TM7WKnTX1iHCrFqsY96Cngg7bz5Lyls9.jJI7YNMx9ykzJgKtwqYd2nQ0DShD6vMUGV
 ozFmPU9S8cIbjupZgMt0u5zE_c4tTe5.8PC9N0R6rfdew0qpOXGmzRbPm2UGOn.yiSkkm2L7FlbI
 awj5jTOvAHdTh6pTL9ADb455b59Ft0E6JKsJFOUndKFSHARrbhxCc7cz0umCmpByLSREc.xfTwLA
 QdkAuCwZHmVXF7RuB9A9PEZtaeB3zBJoxcAOC6yEHnx0c12leh0ImXWJtz68Xvi.9B.IA.3ik41P
 tGkZ_R9mb6uPAu0wECSp1.coCr0EmI.vzYiC_.qwtTd7VDPgTCfCx2pmTKrJJg5wEZt2UmeN8DK1
 TU1YRjITGbS6vuY60KjWXcUqCNqr0pHIVmHNut8OdnOkySYWmufK8hZneYWlyq3h959SyP7RvZft
 PVYqe29AAj6Et0jKwykA.Ab8O.A2z32paQImdY9zkvMV3b8YsHgcVT7Oxsqc7vMi0CzsCa_oNFkV
 LPwGV79YlPqW0YV067IXAKvHWQ8fc8m2S2ApNu0TeQVxUAWrrjcvuAZvgA7CFkJjwMecNl2lFYh2
 YKlywtHZHoD9kGD2UBGFxx6U0t3xoJMxhl8yF3SGG8iyAynXtPdK.VVN0CAUyTNRjvTD03cNHuj5
 PQ36T8ZqhY9mbs_aUmiET53VPiWbp6kDodtRnRoYdMsNQ1BSyuizEoTGLBppEK.hPDqZTuwQwjLf
 4GyC2f58ne006JYNaG1vcG0mL612odt_jWB8vakAB4dW3gqfwZ0ZuUeMvJsPe0SgDOPD8JGos9qc
 XPz1HAyUb1rbKO4R9U8pEyktTycgTSDbZ1o6iJmSKPK0ROkPgBqpwnLMhOJoC7qMLn2e9msSkwtI
 cnTDQ_c84eWCHOmjP.t8JruMSU11xnRrUci.LibjbVIbY7dnFa_xalnycknB.D0DeqrHcb87z59U
 cZJDgUPtbckfvevsE3wwol_DwvWRwKGqrtYezCcoH.Nz8x2ankGjl1QPiEF2WLSX3NTQAAijirW4
 UJiIT.nUeu8e.cY3I.ValgUZumfVp4ZMknK3VC63R.PnjUQGq5Qtq9Ar2Ha.5dXLNmOqC8oP_qeb
 pCP1jE_ZH0vptid8VXEqB0KJM3diVCKL9yZhE62NkQDmuer2ZSglAz6lhlWAO2ldxdaRu_FMc657
 mx5G3MPbyxoJiWPPKnso2TcPUCo5HmMf36x38pXrlpXPgDwQIznG1nxJ05xxydQsduBGRwRotBgY
 aXG1jZ3haTDdVtONbNFFawLt3ocCNxz0mSbpHQ0nRCxuIF9b0Emx8CJ0oE4H68vgfdGGpGU6HFXg
 avZosGIJPdUo69YfQEAYz2wUBaoZ1Y17gIV1YELBKPum8fZycpl4tXzgy5KT1SWUX3HrrjRwu1ZU
 FmMwCJ8naAW7tkDaNnpxZ7ajN8iNOGBNJgQMbwnm8ALJrfO1OM5D60DnJaQJRs7Dy9gFS9PZnmRt
 5EXl8lYrVZio_UBu9T2ADLQAWRfyGcQR6D53eCipMxAQxGZMlJx.jmFCyUpeXCXu2D9qDz1HPpH8
 hnWDTD.3MP0p7_dXWcsSSybJ1yRGsGcsGMuajDdZqxVrTe8fPvF_EDpQZcWnm_bQtefBTkC8LTaK
 jtW.2eSl7Gyn_ExlIbHc70av6dIFDGO1rTGzxzYwa9tRZreUZv2guaXgBg22L92OJGux0ZjFtwBx
 7_FFEDWmAVMx7TFBuLulLFKDdWA4a.CIvj49H719VjpHt84Y6KmjLllzjHz6ezAB2
X-Sonic-MF: <luangruo@HIDDEN>
Received: from sonic.gate.mail.ne1.yahoo.com by
 sonic308.consmr.mail.ne1.yahoo.com with HTTP; Sat, 4 Jun 2022 13:48:07 +0000
Received: by hermes--canary-production-sg3-5f7658c994-r59gj (Yahoo Inc. Hermes
 SMTP Server) with ESMTPA ID 9505297ef9d39679f82c7c50db859eac; 
 Sat, 04 Jun 2022 13:48:02 +0000 (UTC)
From: Po Lu <luangruo@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 <83czfobxht.fsf@HIDDEN> <878rqcacgm.fsf@HIDDEN>
 <87r1443asb.fsf@HIDDEN> <87k09w8wbh.fsf@HIDDEN>
 <87czfo39ms.fsf@HIDDEN> <874k107eqg.fsf@HIDDEN>
 <871qw4369w.fsf@HIDDEN> <87v8tg5z5y.fsf@HIDDEN>
Date: Sat, 04 Jun 2022 21:47:55 +0800
In-Reply-To: <87v8tg5z5y.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sat,
 04 Jun 2022 15:35:53 +0200")
Message-ID: <87o7z81qwk.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.91 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Mailer: WebService/1.1.20225
 mail.backend.jedi.jws.acl:role.jedi.acl.token.atz.jws.hermes.yahoo
Content-Length: 1210
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 55645
Cc: Tom Gillespie <tgbugs@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> I've certainly been puzzled over the printed representation of these
> symbols, and I've wondered whether I should use a transliteration scheme
> (which isn't necessary), so I think it's likely that others have been,
> too.

Fulfilling a niche is not really a good enough reason to make such a
change, especially once it causes actual problems for someone.

Most programmers will not see a symbol with a dot inside every day, or
even every month (the ones you sent are the first ones I've seen this
year.)  Programmers probably come across reasons to use them even less,
and the amount of those reasons is reduced even further if you rule out
unambiguous interfaces such as `intern'.

> Users will inevitably see symbols like this at some point or another.

Chances are (if it actually happens) those symbols will not be printed,
but displayed to the user as the product of something similar to:

  (message "%s" 'symbol.here)

Which does not escape the dot.

That aside, why is it escaping a rarely encountered character inside a
symbol a "problem" important enough to fix, especially when the fix
breaks someone's code badly enough for him to complain about it?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 4 Jun 2022 13:36:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 04 09:36:05 2022
Received: from localhost ([127.0.0.1]:57904 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nxTwj-0007dA-MA
	for submit <at> debbugs.gnu.org; Sat, 04 Jun 2022 09:36:05 -0400
Received: from quimby.gnus.org ([95.216.78.240]:46304)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nxTwh-0007cf-LW
 for 55645 <at> debbugs.gnu.org; Sat, 04 Jun 2022 09:36:04 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=HTbh73DRhnxI24twR3wQEuOvdRztOAB5jmf3dn659KU=; b=i6PKP5qI40qilkVBmM6CR+JXPg
 U5BVOpeJFBtQXASHXJ06iJkbO8Tog/HbU07TDkCVb4b89VPItnUI/kVVK0/rr7zNvELR6T/QD39o0
 R2Dp/5eI23GBirafTVthfSzQVurNzIVSqAz3yYfQQF70w/joAMiDXpkzywkRU5YidEdE=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nxTwY-0005P5-3y; Sat, 04 Jun 2022 15:35:56 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Po Lu <luangruo@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 <83czfobxht.fsf@HIDDEN> <878rqcacgm.fsf@HIDDEN>
 <87r1443asb.fsf@HIDDEN> <87k09w8wbh.fsf@HIDDEN>
 <87czfo39ms.fsf@HIDDEN> <874k107eqg.fsf@HIDDEN>
 <871qw4369w.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAElBMVEUPDxInHCONbKxO
 KEOiOy3///9uRwijAAAAAWJLR0QF+G/pxwAAAAd0SU1FB+YGBAw1FyQTjt0AAAGlSURBVDjLpZNh
 mqMwCIbh6R4AxAOsZA4gkAO0mvufaUk6M9raf8uPqLx8BAkB+G9DZiY6vpl/QaIDYLEkmA40PoOb
 aiG4/e1axFMqdFUCfN9wWmCO+A07FF6wHXJkW79fdaGGcNryJ0QXvCP4+gmswG7v4KaZCFivCg+T
 2q4AoC5Sd71uPredUK4AYvrKDpVrpy0bslzjYX508OFoNkbxxwfQcvnzAcwje7sWuw3XdH/zCzde
 8zznB9tJ5CAzZb8ni7oTUJ8RxhXZgTM55TnDfO/eCBZfOY+TmxsHO0sfD9UOTRaE1vwrYtOwaoxf
 zVjUpoVBS4R6aEQsnL0Jm8oAHl5105yrnsSTh1rk+Eno0zL+Vlt0VckoiAGiuJqI1j3qpsWLQd84
 N8j+lmAte6L82hp0l46lKGW0L2WEgfZUuw8Vieoj/zHzOvQ6m0VUcqMMshyw4iFQIr3ELBRMWRAT
 S+nXKPhpQsYkcUwj/9j7UOPTO4alL3CSjEf22T4oXi7kGfQrzG/kW5ANfSXS0mysO13AHn2NFwkP
 V9Sk9lIA15OCjuL+AZFuUILiwA2mAAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIyLTA2LTA0VDEyOjUz
 OjIzKzAwOjAwf9+2egAAACV0RVh0ZGF0ZTptb2RpZnkAMjAyMi0wNi0wNFQxMjo1MzoyMyswMDow
 MA6CDsYAAAAASUVORK5CYII=
X-Now-Playing: 1CD (2022) - 09 Aquabat's _Illusion_: "(Circle Of Whispers)"
Date: Sat, 04 Jun 2022 15:35:53 +0200
In-Reply-To: <871qw4369w.fsf@HIDDEN> (Po Lu's message of "Sat, 04 Jun 2022
 21:30:35 +0800")
Message-ID: <87v8tg5z5y.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Po Lu <luangruo@HIDDEN> writes: > I find it hard to
 believe:
 why would changing the print syntax of > symbols with dots make it more likely
 for people to use data types that > have type names with those characters?
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: Tom Gillespie <tgbugs@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Po Lu <luangruo@HIDDEN> writes:

> I find it hard to believe: why would changing the print syntax of
> symbols with dots make it more likely for people to use data types that
> have type names with those characters?

I've certainly been puzzled over the printed representation of these
symbols, and I've wondered whether I should use a transliteration scheme
(which isn't necessary), so I think it's likely that others have been,
too.

> Most of those are interned from strings (see fc_charset_table in
> ftfont.c), and not likely to either be printed or to be written by
> users.

Users will inevitably see symbols like this at some point or another.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 4 Jun 2022 13:30:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 04 09:30:54 2022
Received: from localhost ([127.0.0.1]:57900 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nxTrh-0007Vr-UH
	for submit <at> debbugs.gnu.org; Sat, 04 Jun 2022 09:30:54 -0400
Received: from sonic313-56.consmr.mail.ne1.yahoo.com ([66.163.185.31]:44251)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <luangruo@HIDDEN>) id 1nxTrf-0007Vc-Op
 for 55645 <at> debbugs.gnu.org; Sat, 04 Jun 2022 09:30:52 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yahoo.com; s=s2048;
 t=1654349446; bh=rPZRFJb5cnGDvUEDRPCdVBvqI2bMHySEb8OnFiaOHVE=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From:Subject:Reply-To;
 b=lTSVi8rsHVCDaEWg8xnNxkYNX28q20FaWW91mDF6AYJVmhnYRpPdNgELIO2nxieblg7wxA6OUHF5NRaGTK7pPvQgh+VJwUsPOc3XMyDVUwpxsaMWBJYNLP3ca6qdjOlaOQurjAjS9dBOOxhZvbyLBLlJ65lSHgOuPfaTvLINFod/MK9YfRt20Q1v8FWB55p72J8wOBXnd0c7BQwIXv2rrNI76l/SIvTysLtxLFLxbWG1zCtVHoZvePUpkyHgYBaQkg8NEBp3RhVKCQ/lnQ7nRgVrNYilv3UP1/RS4SBrBv8h0q/NTSSWG8kRGj5sQWFu12vc5xoMuL7UtodztMX4og==
X-SONIC-DKIM-SIGN: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yahoo.com; s=s2048;
 t=1654349446; bh=8vqgYskcKy1TIFuFevlZwRu9Y0EKZNdoRcctfJ5fUTX=;
 h=X-Sonic-MF:From:To:Subject:Date:From:Subject;
 b=KmMwxCNUbmcVS27kuF3jCCVoE3ditY2iBu843xh0nyzz4F4wZ2M0uzmzdvA29GZD5lkMCQfcc6nNld9+Bpx5aAYAgl6sexVdqtB1FivlWeGo5AuHbrd+R/aglbG4ORTHw4IU/BdTVH2qkZaEOrxd+51c9E2HQaxqbI/tuTZHQQx4WsB15XKi6EhAFzTb1uYt0MbLOTVHHvXAlqxJjNIGH6z8ASu2VndmgITJiWUalIYgwWcKy+2oedfGDSizTHvZdpbTPS5KW3dLqIDV6/2YH6AUGZ8YU20+UUehIcCL4g0UfS7+yWRgpiJ1qR+hp26nMF/c4rvcfjnajVQn16h+eQ==
X-YMail-OSG: Vagt32QVM1mdFU2oQYoqXWARGBup_qeDZWKrK4MoJxnQWtq9md45vBmDvaGQydy
 KiLDJ2RS50yoU9uJnab40lZMpyIDKPLel9rZ8_geRaNIsQkFkrSo1xQNiJG6uh.kdgo3KNnu5TDB
 2BszfyZAG.sq32XrtZXUIN2rxhxOCMj0mv9pvx53x_zuolG11c_6wmMxeFD6waQHPfsg.VsNMOv1
 Q1A6g6xSD_Z33hhjeQCfDOPtEB.EqLDQ2tTMIZAWQNb_pdec1QfUUu0IIpKWTE4g75_7M4_P3p6V
 rzXMmkJNkH5K3vfaUFywGp20GifHMcGo7dSTxQo.TLIB1E5awzNwv6xdxb3Kkg_7.HMCQh9k5Gkg
 ltUkZ9YR3YNfBz3UFxTRrbUgbmISM3xrcAGwc51UXCozBcly.mlPbx199sPx5dm6emKIO_SjB8zn
 N3QbFdhzDvN1JYkw3vNSzbuNcBI5_R2DqjgS3QRpzDIHHuJCXsag1LlXNrJl.XdFtPAX6zd4tRcc
 ZKive.rIC7g6U5z.bN86_0E92wRiig7M3AFcOLxE2RTiLnzBWSd35JUFAHHRUtn9RMlI4_sS2d7S
 FSAdNr9hYjL6qs3mYPesZP5Ucs24eLTsi0rsYiP3gRYpSm8kiyWYz7cmROX9pTc4pd1DEN.oLidg
 eDZZu.gcChol8rPKnzA.mFVr6ve3g8IpGPNvRUxhoXxK4Bp5i6zj8xveTvHIu9hSffgMQZzxEKBH
 XCSaSHuvmivqIA2KiD9MlG1VGfM5CZ4O_xwt0t5T3TdtaGO2P.cycQ6HV636F0tOvzH.xOkYsAfi
 27ohRnKztrZn3_bPqTGWZ_Y0ItAbg76KpAcBFXJmVRrPYPaqlJURJG_rARniRnXF7vu4f5UE9D3c
 VCEh3HIKjU6pDrDhebyScyudJsPRI4MiSTWLlN5x4h50rQFg5a4Z4NSDJQ3dsnpX1UjiZI4MKIPO
 75ciZluP7iSB9Dkmy1Dn6asKjPRIl.7HE4dbow95zH4jLIssbiHdT4ANfHdD3o4zSG9lcbQBjQap
 xik3bHPxVd34l3ylOUnVZR96TQfPFv_EtLOStGmqd8LriENJqwjQnmO7pz0x1BT.tlwpJeno0lXT
 07qHH6nSHRZQ9YU4kyrfQaQTqSBvOK3VkIiR8Eij8L.Eixm2CiLl5PJBB9L_twV54fhYVEKKA.Z5
 _X5RmaAbvX32gE6ST58mGuUI0OlB9hmfniCGO4ZdM6mchwStz3CwrXIE1QCTwA8KzrvfKSyvSpcy
 vuc5ecHjsfB8FqA4AlveMUlEcWM8EA3w5WhSK0QH394gM_DVSU75r9plapJYocifBTGvLYc9RpXz
 n4bZ1lEgbkiHq4cb5LgWC5xgH2lmGEnoMkqUdB87UVv5fRcZ_mSZGwcchwDtLgnxbUZwmlt1kVJg
 uFaDrH0mZZzO__XzWQfXM4ECGDEShqNZwPONOB6.W0t2uFLzuUwcnTsuSVFC2N_WMCqkLZk2wMC6
 zgXAtdEuZZFPaCezXjOQwHJ5GTesmpUV_73M7NRsfWQGQDR.bbGV1ykn.pXJdOpjQgMP_Wt2qm8C
 .r2VPRnnXV25ZDitwRXD955ZznNfVaEWfjAfr55RlfcfurBfzvTr1y3sqNgYZZHdOoRZIcp5Fd1o
 dlhcTpz0U9l_ebn7RF0gJSfU8pvdeT7dyrJhnSvFdKFQPdV2JCKh1vn0ZPcRJNz5GDrj4hkx3oBi
 WdZZTTL4kJdf7hyeAsCCSCjBgwyy2CruTWkpN.c6aCsMbfKV0AFjlrFMwqfPaC_F2E7Xn509moDO
 z0pwxL8oPGxHBy.hf3_VbwKeP_DtI7zJHn_ZO3Le3C30TWEc0dRB9CQ_gUoOy0dtZhddX4YI0rd9
 pKBVaMny9e29biRWAC_qs618ZACNm.5zfCFQy7k2itcPvcqDDjfYlLv7g3nfzb75J_4q61ENHS.i
 amVIdYTn8tyrITZPOhucxmciZvfMs08olwkSdygM8X2cLiLjouBpTjrd_tHK0fHZp6QKgt8Vv_zh
 HYDJ0tcOIdD_LOwWw8osAqQ5j2cc7BFeZ5_KORISLTuKxjrSfnl5ItKQxL0_zRYXx4..vA8kEjKo
 7nG55DjnUQ3tnXZRgstFeOue2P7bdYxz6vbvjVK_b2jTNzuyEyvN4Tf.Q2tSE7GJhX5EHak4rHjs
 j3etms7XbbOupJTogh_cWb6XoCGVeD.Abp4aHq.xAWE1oSkTXa2UeqXc4.NGTn6E.Nt3NjmN_oxZ
 h1xmu6bbvONKhCDa4xNEHIRtMW1AaU8jjQRnQy5c4YOooXAEEdN1G7tl8wwhdHqnPMB7L
X-Sonic-MF: <luangruo@HIDDEN>
Received: from sonic.gate.mail.ne1.yahoo.com by
 sonic313.consmr.mail.ne1.yahoo.com with HTTP; Sat, 4 Jun 2022 13:30:46 +0000
Received: by hermes--canary-production-sg3-5f7658c994-zbd6m (Yahoo Inc. Hermes
 SMTP Server) with ESMTPA ID 2ace7f38ee8c9194ad46ccb6ee037d1b; 
 Sat, 04 Jun 2022 13:30:41 +0000 (UTC)
From: Po Lu <luangruo@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 <83czfobxht.fsf@HIDDEN> <878rqcacgm.fsf@HIDDEN>
 <87r1443asb.fsf@HIDDEN> <87k09w8wbh.fsf@HIDDEN>
 <87czfo39ms.fsf@HIDDEN> <874k107eqg.fsf@HIDDEN>
Date: Sat, 04 Jun 2022 21:30:35 +0800
In-Reply-To: <874k107eqg.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sat,
 04 Jun 2022 15:14:15 +0200")
Message-ID: <871qw4369w.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.91 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Mailer: WebService/1.1.20225
 mail.backend.jedi.jws.acl:role.jedi.acl.token.atz.jws.hermes.yahoo
Content-Length: 1017
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 55645
Cc: Tom Gillespie <tgbugs@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> I think it might happen more often if the printed representation wasn't
> as ugly.

I find it hard to believe: why would changing the print syntax of
symbols with dots make it more likely for people to use data types that
have type names with those characters?

And if you mean in general, then I don't see the point of using dots in
keywords and function or variable names.

> But we do have a bunch of symbols in-tree that uses dots, too:
>
> (mapatoms (lambda (k) (when (string-match "[.]" (symbol-name k))
>                           (insert (format "%s\n" k)))))
> Lint Directory...
> iso10646.indian-1
> gb2312.1980-0
> cns11643.1992-7
> cns11643.1992-6
> cns11643.1992-5
> cns11643.1992-4
> cns11643.1992-3
> cns11643.1992-2
> cns11643.1992-1
> Reset Counters for Function...
> Instrument Package...
> Lint File...

Most of those are interned from strings (see fc_charset_table in
ftfont.c), and not likely to either be printed or to be written by
users.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 4 Jun 2022 13:14:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 04 09:14:31 2022
Received: from localhost ([127.0.0.1]:57886 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nxTbr-000777-4Y
	for submit <at> debbugs.gnu.org; Sat, 04 Jun 2022 09:14:31 -0400
Received: from quimby.gnus.org ([95.216.78.240]:46042)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nxTbp-00076r-2z
 for 55645 <at> debbugs.gnu.org; Sat, 04 Jun 2022 09:14:29 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=ztkg8Z5BDi/7R5a/wsWWKiW5TyR3/UaDDMc+Z5Mq75I=; b=l2alOH+aikpPj5YIZtf02MZv/8
 2waq0NqAuIIuncAS8rfdWO37UGWRckVMkN9DQpwZCwpTZZ675IFEvJt31FsgvhWw0DaktVD0MNK+b
 9f6POUYkNZp9QICBAnA1Nq8mz6vQoNVGVRliIsJ+foTOI1kXcUv9rvalciEMxJDg40gI=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nxTbf-00053d-Ky; Sat, 04 Jun 2022 15:14:22 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Po Lu <luangruo@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 <83czfobxht.fsf@HIDDEN> <878rqcacgm.fsf@HIDDEN>
 <87r1443asb.fsf@HIDDEN> <87k09w8wbh.fsf@HIDDEN>
 <87czfo39ms.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAElBMVEUPDxInHCONbKxO
 KEOiOy3///9uRwijAAAAAWJLR0QF+G/pxwAAAAd0SU1FB+YGBAw1FyQTjt0AAAGlSURBVDjLpZNh
 mqMwCIbh6R4AxAOsZA4gkAO0mvufaUk6M9raf8uPqLx8BAkB+G9DZiY6vpl/QaIDYLEkmA40PoOb
 aiG4/e1axFMqdFUCfN9wWmCO+A07FF6wHXJkW79fdaGGcNryJ0QXvCP4+gmswG7v4KaZCFivCg+T
 2q4AoC5Sd71uPredUK4AYvrKDpVrpy0bslzjYX508OFoNkbxxwfQcvnzAcwje7sWuw3XdH/zCzde
 8zznB9tJ5CAzZb8ni7oTUJ8RxhXZgTM55TnDfO/eCBZfOY+TmxsHO0sfD9UOTRaE1vwrYtOwaoxf
 zVjUpoVBS4R6aEQsnL0Jm8oAHl5105yrnsSTh1rk+Eno0zL+Vlt0VckoiAGiuJqI1j3qpsWLQd84
 N8j+lmAte6L82hp0l46lKGW0L2WEgfZUuw8Vieoj/zHzOvQ6m0VUcqMMshyw4iFQIr3ELBRMWRAT
 S+nXKPhpQsYkcUwj/9j7UOPTO4alL3CSjEf22T4oXi7kGfQrzG/kW5ANfSXS0mysO13AHn2NFwkP
 V9Sk9lIA15OCjuL+AZFuUILiwA2mAAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIyLTA2LTA0VDEyOjUz
 OjIzKzAwOjAwf9+2egAAACV0RVh0ZGF0ZTptb2RpZnkAMjAyMi0wNi0wNFQxMjo1MzoyMyswMDow
 MA6CDsYAAAAASUVORK5CYII=
X-Now-Playing: 1CD (2022) - 05 Sea Sapphire's _Illusion_: "(Circle Of
 Whispers)"
Date: Sat, 04 Jun 2022 15:14:15 +0200
In-Reply-To: <87czfo39ms.fsf@HIDDEN> (Po Lu's message of "Sat, 04 Jun 2022
 20:18:03 +0800")
Message-ID: <874k107eqg.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Po Lu <luangruo@HIDDEN> writes: >> It's mostly natural
 when dealing with data that arrives from other >> programming languages that
 we then have turned into symbols. So you >> have symbols like `vnd.ms-excel'
 etc. (We don't use dots [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: Tom Gillespie <tgbugs@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Po Lu <luangruo@HIDDEN> writes:

>> It's mostly natural when dealing with data that arrives from other
>> programming languages that we then have turned into symbols.  So you
>> have symbols like `vnd.ms-excel' etc.  (We don't use dots in
>> function/variable names.)
>
> But that's not something which happens very often, is it?

I think it might happen more often if the printed representation wasn't
as ugly.

But we do have a bunch of symbols in-tree that uses dots, too:

(mapatoms (lambda (k) (when (string-match "[.]" (symbol-name k))
                          (insert (format "%s\n" k)))))
Lint Directory...
iso10646.indian-1
gb2312.1980-0
cns11643.1992-7
cns11643.1992-6
cns11643.1992-5
cns11643.1992-4
cns11643.1992-3
cns11643.1992-2
cns11643.1992-1
Reset Counters for Function...
Instrument Package...
Lint File...

(etc.)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 4 Jun 2022 12:18:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 04 08:18:27 2022
Received: from localhost ([127.0.0.1]:57833 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nxSjb-0003Zv-3N
	for submit <at> debbugs.gnu.org; Sat, 04 Jun 2022 08:18:27 -0400
Received: from sonic304-21.consmr.mail.ne1.yahoo.com ([66.163.191.147]:41074)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <luangruo@HIDDEN>) id 1nxSjX-0003Zg-9P
 for 55645 <at> debbugs.gnu.org; Sat, 04 Jun 2022 08:18:25 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yahoo.com; s=s2048;
 t=1654345097; bh=axtu5wuEHjTGAN/2wAX1SMIKH3UO8IG9o1i3o0eYnRY=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From:Subject:Reply-To;
 b=XmBaxAQWesOTDrfgb/Hc9gjOQdbV9J7ITnuxqXE2tH/nt2SReT3d+WnwD1FOpquTRhnKkvkuNWpsb3Zu404OLOj1znlozUh/Tl74+Q2DXTB4nPn+UFwjZ45fRBj4aYmB7frOAqI2eCCzIPElLbwnStDSjkDLcfrWDl4r1oDkEIbGz6bem4PzqVv13e+KLZrTq0/REHsnsuyj9UPDR1fDtjJyElPlFY9odbbxabd6vkCv3lc9HJvbrR9YPushhjx+wjA3UNMmfKZMt7pxMYRKIuG8A+N84XQqP2rOjX8l3vtMXNx+puotXm1+xtIMd3Ecb8U6AkkKbBKemRWwbt8p5w==
X-SONIC-DKIM-SIGN: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yahoo.com; s=s2048;
 t=1654345097; bh=31XnkDEdx/9KjjDTSLdgFKIciBdif/leZ2gQFgd2a0t=;
 h=X-Sonic-MF:From:To:Subject:Date:From:Subject;
 b=rth1FsQFsgT2LYM/D/wvoA134kjB4wPID8FOk7/wOVV8hjcN8u1aMTZIDNI63LmLBms41XcwGiVOFZPWL240ooNjyfx8yEkItxr6NIsH4oaKheyurs7iYUC9Liy4l0ny3UHvOV99FrMhhs2Zh1eRKXnmiR1XcvdTJ5LHNb61YLXK3APVqShVh43YlsXo1JFFZk0Dp1m3rmD3FJ8NHmGiE2Fc9kr7DztX/ozlyOgCKN1aqlcHYUlyyX2N9nOtYOXIjlMg+ZgiL9yizI+b0VmRBL0IFBbPRM0m5X7J2wvvpToOa7CRsWjAJtmgCQ+1UNiQDGVRGTqGe49gHnMe2BzoyA==
X-YMail-OSG: Fq8ddgsVM1mi_QQ_WNbaVfl0GHOGgMEAQsNsxYcVCpcZjk24sEjQYdQwB9aJA3h
 _DnmU3IUSfJcsMUMBlfc4YcefZ3Dbjse0DLFykT34ZpddirFRlnCv3A8R8gWETgNFoi3nnfBK9Eh
 TCfb8A4GVvqRRB10rqUci.qTVNEP0bxPulI_JvReQrQcjAbIAQ_P_OF0QtD43em750A2RLWpmkrw
 I8V20wKuSXfGSAGdbJi0EgqPTzpeKGdnKL580ZlGXIpCs4NmwjTYWAfwtByYwnPxdaRYZuU7qjvS
 O7YetdH0ndOij9_6S7SUNYTt.Lid_4IyzQQJQKAQxfksKtAqO8grBlp5jtr7oFtrUph6rXqoyzhm
 cNsP4v7M_IqAdYasXCq_46lLhBYL2ZqsADGus9._IX3OhSuTZYMnOP5lTj72jR7nVxaPLjQEhrok
 RPhun430M.NBv8gkkHiYL6NFErRUzjCQR3sJpD19qH8w.zVYoZGUD8.zOb1PL1E40Ld2WNfqDWyQ
 v3tLB9Vweu7JpLYpqGh6NkyvQlTZLXionLMikBYPh1_ZfnPTXlrh7Kh3ZSFCcWrTiY6NZcf5cR__
 5z7nWLN2GC2UI5FdGlFp48gFDhKjp1Xx3cwTCD2MNVEV9gcdDqebHN.wAaYGG.LeGUThpRoqBHj.
 EucJyD8YoBuQVySW.E1r0DsZOQY4hhOAUcxWbPCvfgM_w0JzeeQhJv.3zzysJqyk97ka24pxN9Z3
 O0hT7sHa.rhX5YcI05KblrVBqPO0mtuZ41.b2MCD4efz0rWJ3fWLeSLOpjfjjybl0FPjf.EpA1Es
 7A8D6k9EBQ_8wxDmwJmQut2SZki4upgjgdSQwPMjijSVrLWV1fdEtuNNtevvzi9jOXBYD.isiPuU
 mqrc2A0OcFSl1fv97u5eeHN9Nn_53_kv1TKXQsIlVwPP9H6sIn58xZsrMqhs.4_WY34EGLRssvdI
 KgxhjzD2XPQCg6WB38pZnmm9G_FLAlwMTVGVeReHShsKCw3COuReC12IBtY9YyJwnYSiIgiIxIXb
 muY_005B1NPUTgY6g2ANWzwp.8Jbq9w14SURRqUSD61YJEDMAxN0u8rd9eNFprvDHeACsyfCs43o
 pgY2cE40HdjnjYVl71wNXGvTzBL.vDYGwBqPoUfW_BTeeH3o8wRyMK1M8y_vvIGwjpDJ.vtTVoFD
 KBt.7qo6iW_ZnRENySgDiyMSMDQIWE2G_Akk3W75bekCm9O9bM0FITM.8F7M6R9OJWtQ0H1wY8JA
 pq7F1_MbPeW0z._O7oiolkOtX0CAxklmPebP78B_jLNE_B45Yws.Rym3qGXLo1MEypABCgqGgCah
 YJ_BynELAyQ201J91cW4J16SOs0_EgjIMAu9jqbYvk1i_SRD62n1CSj4ymNAjxtzerQ9y5ZmqZmG
 UMhcvWsUZs8P_QRUsqKxDq38lIsUaAkzDVKI4KNlQf080gu730cKffZ31kPKW99K_CEExsw3apss
 EXXtDTybw8nUzwO4mvvfnKNWzFa7bnLza_y.0mrKLfjffJqJ6fXXkjzmMEOKeEDo0v1g_yEKLOVb
 am6_FFDaMalnCZ8cvLvIe02jU4TwzaJro5No_9jrQY7zdhGvCneREOhdeYl6GS_5O8I_n.k_eLyl
 tq7cgP6ftAKTGtFD_UlpMo1eLAq.OakH6CmnSeBs0fsow0IkLYvxmgWDQaqiQefHXRxojoZKLarM
 ye0I4wbKec_fwPcTOs50Q.LtJHg7QaoGtDjnv1MHWZuycagoXnPsEejabFh0u6YrrSKSbMZ9TZLN
 WOJ4MgG7JSS4rR03BqavH534ADAgQP6N1WiIIdMA0a2MJaZUfY2oYtAprQbpywZdThLryKz_dl0d
 az6WWq4bigF061HAI5vhC3RqpFCRUgUpup71WwsiOlOSRoWXSUcBib4_oCc76f.OmpL8UY0aYDsl
 ERL1ljXfqR8wid3SPKkh5FoT8MRn7bjKmFhwOkwzx4hTAmJ2Lk7733mNOw6tmRqPVWA08wtIprAg
 9mH._NDLtgZ01sg17.150MQx0SkBUQjse0aZwiks93UVmPWUqVspwqrT05cbXVjJAjdEhhWuYR00
 YgiUimvY_COuNTDZjAB8E1KWD.7doxaKt0Z4WKRi2HaDjg2mNLUvtEtbbddxVFfsGlA7oOzGHFvw
 2s_cTqzDOXHx85Jw9h_Myb7JDkRx.BUSAeX49ZIfeZfmUJ.HT3jeKjhLtBdwgLmnaRVnPciLuvq.
 zguUH179i.nlycAlRc9lytsOQd7cCzLK7NfecDuXCstk4Tac37hQv5k2PkwC_.z0-
X-Sonic-MF: <luangruo@HIDDEN>
Received: from sonic.gate.mail.ne1.yahoo.com by
 sonic304.consmr.mail.ne1.yahoo.com with HTTP; Sat, 4 Jun 2022 12:18:17 +0000
Received: by hermes--canary-production-sg3-5f7658c994-6jtvl (Yahoo Inc. Hermes
 SMTP Server) with ESMTPA ID fb05f3d9398cd741a37227f7b029218c; 
 Sat, 04 Jun 2022 12:18:12 +0000 (UTC)
From: Po Lu <luangruo@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 <83czfobxht.fsf@HIDDEN> <878rqcacgm.fsf@HIDDEN>
 <87r1443asb.fsf@HIDDEN> <87k09w8wbh.fsf@HIDDEN>
Date: Sat, 04 Jun 2022 20:18:03 +0800
In-Reply-To: <87k09w8wbh.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sat,
 04 Jun 2022 14:09:06 +0200")
Message-ID: <87czfo39ms.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.91 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Mailer: WebService/1.1.20225
 mail.backend.jedi.jws.acl:role.jedi.acl.token.atz.jws.hermes.yahoo
Content-Length: 693
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 55645
Cc: Tom Gillespie <tgbugs@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> It's mostly natural when dealing with data that arrives from other
> programming languages that we then have turned into symbols.  So you
> have symbols like `vnd.ms-excel' etc.  (We don't use dots in
> function/variable names.)

But that's not something which happens very often, is it?

IOW, this looks like a relatively unimportant asthetic issue that
doesn't justify strong opinions in either direction.  Even though
there's no guarantee that the printed representation of symbols will
remain stable, we might as well do Tom the courtesy of reverting that
particular change, since it caused him problems with code problem-free
since Emacs 18.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 4 Jun 2022 12:09:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 04 08:09:20 2022
Received: from localhost ([127.0.0.1]:57801 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nxSal-000196-Pw
	for submit <at> debbugs.gnu.org; Sat, 04 Jun 2022 08:09:19 -0400
Received: from quimby.gnus.org ([95.216.78.240]:45438)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nxSak-00018r-A2
 for 55645 <at> debbugs.gnu.org; Sat, 04 Jun 2022 08:09:18 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=FcuFkUxFeVaoI4FGSgIMHX1goaw4+4h/qjQXKoxN6R0=; b=cdjvzfnMqM14uzwnXeD0jODj08
 ekfaRapi9Rng+AyAd3RTkAEHCZyLD86SEv4+M6UOsgPEVmhuAAS0dhgzjV/5wYgZzYihPwAPAGpOQ
 DoclhWs7BfzXDaJfcGIrpudd+so0nJE2dtVVGVYkIdXXuwWWOsj9Lw6zMZF8w5oxEbig=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nxSab-0003nr-17; Sat, 04 Jun 2022 14:09:11 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Po Lu <luangruo@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 <83czfobxht.fsf@HIDDEN> <878rqcacgm.fsf@HIDDEN>
 <87r1443asb.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAAXNSR0IArs4c6QAAABhQTFRF
 /f39p6WkdFy0+doTS0o6NzIIAAAA////FGch4gAAAAFiS0dEBxZhiOsAAAAJcEhZcwAACxIAAAsS
 AdLdfvwAAAAHdElNRQfmBgQMBRESNh0bAAAAYElEQVQ4y2NgIB0IYgCCEkroQBGXhBJOCUWCEsYY
 gKCEaygaCIJKhKWhgZRRiVEJvBIpQkpKWCVSXVxcsOvAJUHQcgacEkK4JBiEcEkI4pJgIF2CwQ2X
 hIoLGnAko+wBALaZH0+PBoXsAAAAWmVYSWZNTQAqAAAACAAFARIAAwAAAAEAAQAAARoABQAAAAEA
 AABKARsABQAAAAEAAABSASgAAwAAAAEAAgAAAhMAAwAAAAEAAQAAAAAAAAAAAEgAAAABAAAASAAA
 AAEfUvc0AAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIyLTA2LTA0VDEyOjA1OjE3KzAwOjAweVZJjwAA
 ACV0RVh0ZGF0ZTptb2RpZnkAMjAyMi0wNi0wNFQxMjowNToxNyswMDowMAgL8TMAAAAXdEVYdGV4
 aWY6WUNiQ3JQb3NpdGlvbmluZwAxrA+AYwAAADh0RVh0aWNjOmNvcHlyaWdodABDb3B5cmlnaHQg
 KGMpIDE5OTggSGV3bGV0dC1QYWNrYXJkIENvbXBhbnn5V3k3AAAAIXRFWHRpY2M6ZGVzY3JpcHRp
 b24Ac1JHQiBJRUM2MTk2Ni0yLjFXrdpHAAAAJnRFWHRpY2M6bWFudWZhY3R1cmVyAElFQyBodHRw
 Oi8vd3d3LmllYy5jaBx/AEwAAAA3dEVYdGljYzptb2RlbABJRUMgNjE5NjYtMi4xIERlZmF1bHQg
 UkdCIGNvbG91ciBzcGFjZSAtIHNSR0JEU0ipAAAAAElFTkSuQmCC
X-Now-Playing: Farben's _textstar+_: "FF (Remaster 2022)"
Date: Sat, 04 Jun 2022 14:09:06 +0200
In-Reply-To: <87r1443asb.fsf@HIDDEN> (Po Lu's message of "Sat, 04 Jun 2022
 19:53:08 +0800")
Message-ID: <87k09w8wbh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Po Lu <luangruo@HIDDEN> writes: > FWIW, I don't see how
 it's natural to use dots in symbols. It certainly > feels weird to me. It's
 mostly natural when dealing with data that arrives from other programming
 languages that we then have turned into symbols. So you have symbols like
 `vnd.ms-excel' etc. (We don't use dots in funct [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: Tom Gillespie <tgbugs@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Po Lu <luangruo@HIDDEN> writes:

> FWIW, I don't see how it's natural to use dots in symbols.  It certainly
> feels weird to me.

It's mostly natural when dealing with data that arrives from other
programming languages that we then have turned into symbols.  So you
have symbols like `vnd.ms-excel' etc.  (We don't use dots in
function/variable names.)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 4 Jun 2022 11:53:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 04 07:53:27 2022
Received: from localhost ([127.0.0.1]:57779 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nxSLP-00071D-G3
	for submit <at> debbugs.gnu.org; Sat, 04 Jun 2022 07:53:27 -0400
Received: from sonic314-20.consmr.mail.ne1.yahoo.com ([66.163.189.146]:33507)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <luangruo@HIDDEN>) id 1nxSLN-00070z-1p
 for 55645 <at> debbugs.gnu.org; Sat, 04 Jun 2022 07:53:25 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yahoo.com; s=s2048;
 t=1654343599; bh=Y1YUIXA19CjZlSbxwv+P4y27PSYjJ8txYeJw26kPBSw=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From:Subject:Reply-To;
 b=ma/e1Mn3fVegDQzDowMj2oWRLJbXC7+zJ6Tg7xU8xIlEER/6PCO1GT9v3D4kbNoCKoPMYcqYDPt/sfY4rCIz1WLMQOPb7JOeovE6rq40oejk6Yf9pA2WSz13yl/cOwIEUK1pbqfXIU3QKgqbDxedWY/hBpjDcMLadyEbJ6tYcL2SI+HMhhalLWAD4UK7mWJEHmJw73KxRLSULaR4jqQq1NBGvM0K8EWYfHCPWTdKydrJyvgvDJA9K+q4GIP26wJX1rSRrn7w+jBJn/l4FjrBojrjPh4Z+jdu1creH+TjjqNnawJtQbQhYgL/YIsKRzEad0sNnKzgfPvfyZs+jxMskg==
X-SONIC-DKIM-SIGN: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yahoo.com; s=s2048;
 t=1654343599; bh=pkh7/afaLantkcnuLLthD8oSvbYtLPLxKkrrJl20n/S=;
 h=X-Sonic-MF:From:To:Subject:Date:From:Subject;
 b=nemnNAUenwEB9L8inlYEkwSwvM837Z8/B5C7FSwgGW3qCcj5zamZ6biK4vyB3OMhXeqa5ySoQQnZc95zgyPtI4zbPpXvTyK+sIOBCNIxC40JWYUR/BLs0IPNS82L/fJ0lt5pir6GgnBCO0RFjPaBMhkuDQ03PXNC217x3PltgYOwAv9A9R++v8v70qLny65AxTbvvHmPno/pIciw0Hqkp2uGTFgAVfdEoC+341LkRHrSInfp3mEvjspoF1x/KVhUoHzmHA8Arx18po52Y7izlh6vL79tjHRatyozoYDB5HXF88XBLjrK2D1lMUdWmI8BZhKjWLB+CZFVnwFHfDrDUg==
X-YMail-OSG: Osj4DE8VM1kAWTtjnAC3JkNAQe9NbO1gbGAlSidKYPOSpgfjH3XKBZ96Wezf0Dq
 yzR6k51vqRnF0X.54.J_V4OrO4KiHv8rz578tejxoaTcv6FWDGQMQ2J5n80lT3S1Lp_hc2LAC2ik
 RBe8tR6H5TG1pnqvfvhYzLgsMmW3caCZexYivMyvDAt4t84WWGpqcm1j6xCtBvZUEnV_Gbqey1qE
 T85zDs3TMj7sPRwTT1rJ43rk5JMmpdAYsGcIv1Sn8QulGCpmMq21CIY_24qvJBlCXmksluWuDa48
 rH1rPe4enucm2snCPX5O_f6_oqOutl_H9MhRwZE.MN11SFEK8hcKrzKOX2Tma1Vc5oy_JHZrtljZ
 4kV8Jm88POXPF3r_L_WQHWGyrRIqdYL_FfauZuyJDjG2JE82HTjBC2AYx9gfmD86UW9Yu_jgTE_t
 cuL9_tfnbhrmpPTovgwJNO5BaDlwL8ZC9hrav.EZwNSLzzzmIklq6Vre2UG9..TnR0HWnjnb00IV
 bWmzoLMhd5jnHVjgmM5Dumlzh1lC7X2tARtbesP13ZIjqyMfBOL1rFS5FPF3JcHyZ4P5wuufcuB1
 WXXrztIMDZYu9POSGQwwObBTz48j_8g70qvtMkqwbfN2ybyWxBAsBBhgKl6jcNgS5Y_ELkbfB2cI
 xUCcFbkqG8.lIONa39DtfJ6QS0CC2SgAmKXOrNoQu4RyKRtZPW2L.JtWSucRowce.lySZ1QIohyp
 2AxTWk0Glv.NUf0ZDDShcTBeXKJ7tXWxoA9KV4h2AkkXtskj0PR33TAIb_LPcCmFrHq01TdPyCQg
 z3IlopY2dj3xl_PklvODzfNymuLpGMS.otENndk4Z3Z6qlvl6n9MPSrsU_toi8CZZMVoCYK1aTya
 tQ3l5uq2cdz5tEp97K8yb186upCmHdkfSA1owtfFv9LZp86sD3qXC5zYJhVXU8kJkWT1vJ4.qpRw
 1ef8xRjuBAT0r1XtmwnBsxk5e._6VxvunBFyGZ.3c1bsPuv8GnB.uOfuNhIhXjAJQM8Gmk3gPDlr
 3Z6xIM.uovJMQwFBOJC2wJGeptrwWlsDd9IJbTK5Nlywxa8iybTgaYFR700aCK5ia1a5oaL_d_p8
 fisvebstIULQbYOkfky_NuFC4_04JAK64p8qOB_zfne8gmVU6L2xJgl9Kft51ncKLg4YUTkYXVfB
 UL9uB.O3pp6IzQxnR8qEo7rle.eqjCYnIlSF53V3agBLDk7QMBYFuF_ZSm7uQJqMteZ4YdeV2Nr0
 2Dj0dUTzfNiGiAdcDe1gWp9Ztd931F8Q.CI58nX8Y6ubzeCghhSjRc06_.w0CHn18FIRI3RJNtaq
 R61p016_2fqN3IbMy1ssemMQpzhoyiNfEzVnoRtA2iAEWGPFRsB8fZacXFgEbLlqi8V5bcTXs4fc
 nwQiNrN7THBoN6X0y0ZvUIsGWYq_2kfBL7mAMjpIDUDmY8iP1Q19ITjZ5MROwYMdz_7AUbioPdqR
 C7wvIRe9kQ4UjquNbNZLzpHI4c5LkFDtx42qI6JxbvSoWB4yKi_n57xtTEZ5Q6vNV8pzvel8b3oX
 ZQp8p6Z8.JEdi22byIzX7Wwq.Drfe7OlMkP0q9Q6yCQu20Hiy7tPd8YR_rp5y.jrfCqMa_0P2GYi
 iayLbStQX6lfvFw1jZoicbq.COKv3beZvOyol3_4_67QvVxLV_lWGoAhZ4276mHzqNuY6XIqF3xi
 HzDI.jZGXmTqHBIWcHxI6iS3_1SBOERUeRnRnrJdjHGOIgXnrdiqpwH5uTorBsNxV1ipZMraQfrO
 Aq.1OgTF3bh9OMjw0M4j0aIiWPAuITcaClpj7RFbHjo5EvaXpSI1QCuYgKbcmf8WeJumulvk7jG3
 8YeFLEz.JIlykdZIymF5az8msJ6Rt.QeL5xjVSsvVlENjudXj.DvhUqu_0xobtv7N4YwJ_WNzWcx
 wrNoZ4_gjXXciFsza1VWYf_8ozHxSPRSxn7t_Rsm1Ym0ocXpeI5w4fP5wvoTdzghUq4LoIlzDa0a
 aJdTBRh4c2fH0nSnjy66hT3AUWFKFxteQhZj_mcbLG0TFuxH4UDz0B7hGwvE3XmQiohSFL8dF5tK
 DKThfcvYDWxWDVV3ILC5jpen0pQSo0YzhDw2QbxK99Cqp0dqEZK5ctHL58G9Mxwupc_kp2izwYYI
 UEnmQ4tYvnvh1xqMOR7Q7ZOWDZlqiTxHhTrEFitMI0EZWpga7uIGleUoSLXt2Ba7ejKOGbbbLm_l
 A9mC4KsQpWGXLelhvkVXUsSArrK_Z6lTANLaEnEi4jYkqgE1roBIC0mNdXHykP6kS
X-Sonic-MF: <luangruo@HIDDEN>
Received: from sonic.gate.mail.ne1.yahoo.com by
 sonic314.consmr.mail.ne1.yahoo.com with HTTP; Sat, 4 Jun 2022 11:53:19 +0000
Received: by hermes--canary-production-sg3-5f7658c994-7rkj7 (Yahoo Inc. Hermes
 SMTP Server) with ESMTPA ID b4b73e982b105c326a78e2bd4bb8daaa; 
 Sat, 04 Jun 2022 11:53:15 +0000 (UTC)
From: Po Lu <luangruo@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 <83czfobxht.fsf@HIDDEN> <878rqcacgm.fsf@HIDDEN>
Date: Sat, 04 Jun 2022 19:53:08 +0800
In-Reply-To: <878rqcacgm.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sat,
 04 Jun 2022 13:35:05 +0200")
Message-ID: <87r1443asb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.91 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Mailer: WebService/1.1.20225
 mail.backend.jedi.jws.acl:role.jedi.acl.token.atz.jws.hermes.yahoo
Content-Length: 498
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 55645
Cc: Tom Gillespie <tgbugs@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> It was mostly an aesthetic change, but sometimes aesthetics are
> important.  People do use dot characters in symbols, but it's confusing
> to see Emacs display these in a weird way -- so they may be discouraged
> from doing so when that's a natural thing to do.

FWIW, I don't see how it's natural to use dots in symbols.  It certainly
feels weird to me.

Symbol names should ideally consist of the punctuation characters
"-+=*/", letters and digits.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 4 Jun 2022 11:35:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 04 07:35:17 2022
Received: from localhost ([127.0.0.1]:57733 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nxS3p-0006VC-0U
	for submit <at> debbugs.gnu.org; Sat, 04 Jun 2022 07:35:17 -0400
Received: from quimby.gnus.org ([95.216.78.240]:44984)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nxS3n-0006Uv-Ap
 for 55645 <at> debbugs.gnu.org; Sat, 04 Jun 2022 07:35:15 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=pYK7+Tcuz6LOMTuISxdNGnFdUFb0YTOwrDVKkajX2IY=; b=QJuwyXlNyFJA1AIfjB6vPWF3Ki
 DOnWa5+V2X/By0mS/cmhuKqnWgz9OM8D87AEf3peH3tlt/fZiOUvxy4eUV5KXjmKGrlk+4gKfoAUD
 WCCUpwXpHvhzVDHrrzb2wqUIEIbTZE3NEw6jvYE/RzAL2pvxlPgNWzD3itxP4KPIPT5A=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nxS3e-0003CS-AE; Sat, 04 Jun 2022 13:35:08 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 <83czfobxht.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAJ1BMVEVlMyKAPhUgOGkX
 N3U8VUmNUyabaU+2kmrFqowDAwMUKh1WgIP////7CihXAAAAAWJLR0QMgbNRYwAAAAd0SU1FB+YG
 BAsWC4v0s3YAAAGkSURBVDjLndFNa9swGAdwpTQpyckuK70v/QT1sZcwRLa4F3cgp8cQbGn0Psns
 XGIfRwmlj3sxxWPY59KN6stVsvNay4ftD8JGPz2PJRl1bKtj17HUOHBWQahj2dtYO2BtVqt0jutp
 7KATgq66tu1blo3CrneIP+IzNRw0FSScEvLtO2Ek9MMPtEqoIYniJBZRohPNAxpocdBpLJJpzPl1
 LOJEREFA5zUcxWpdEtcFNAmCupeDelwwzvmUCSYEYV9Vr/GY4iGCtCxBRz3V29PmHFCWRQWgoTRB
 ug/rTv8F7h7orUCaZTNI8QbOV5B11e0MoGxU/PQZn6nCpduAiHsD0M12IS8yX3BP7yF3dwEXqEdp
 dcoc74GLBllY7XiJP20hxy+/vLBbVaS7gPEo8ynpGwAjRsP++1Y5vpQzxmarK77bAMZSPvviBhpw
 KaX0qQHUvOxRzwjFiJAGqE6T+5sBMsAEvkyKsgHyFSCZADQB4JGbQBU8LH4YQC1eLm7NAJ/b4HfQ
 An9dA+hb/dMG48IA1f+BFoAGDFvgQrbC8B8r1h8vDPAGknPX9K4yzwoAAAAldEVYdGRhdGU6Y3Jl
 YXRlADIwMjItMDYtMDRUMTE6MjI6MTErMDA6MDAd/LLDAAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIy
 LTA2LTA0VDExOjIyOjExKzAwOjAwbKEKfwAAAABJRU5ErkJggg==
X-Now-Playing: Vinicius =?utf-8?Q?Cantu=C3=A1ria's_=5FTucum=C3=A3=5F=3A?=
 "Vivo Isolado do Mundo"
Date: Sat, 04 Jun 2022 13:35:05 +0200
In-Reply-To: <83czfobxht.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 04 Jun
 2022 12:15:26 +0300")
Message-ID: <878rqcacgm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > Another way forward
 is to revert the change. And here I'm asking Lars > what are the reasons
 for the change, except some aesthetics-related > considerations, whereby we
 basically didn't see why the [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: Tom Gillespie <tgbugs@HIDDEN>, 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Eli Zaretskii <eliz@HIDDEN> writes:

> Another way forward is to revert the change.  And here I'm asking Lars
> what are the reasons for the change, except some aesthetics-related
> considerations, whereby we basically didn't see why the escapes are
> needed.  If the only problems are that we didn't see a good reason for
> keeping the escapes, perhaps now we do have a good reason?

It was mostly an aesthetic change, but sometimes aesthetics are
important.  People do use dot characters in symbols, but it's confusing
to see Emacs display these in a weird way -- so they may be discouraged
from doing so when that's a natural thing to do.

So I'm not very enthusiastic about reverting the change, especially (as
you say):

> If someone would show me a design that is based on this, I'd tell them
> they place their bet on a dubious horse, and suggest to find a better
> design.

The reason for reverting it would be to support a use case that we don't
support anyway.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 4 Jun 2022 09:15:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 04 05:15:50 2022
Received: from localhost ([127.0.0.1]:57644 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nxPsq-00083o-6S
	for submit <at> debbugs.gnu.org; Sat, 04 Jun 2022 05:15:50 -0400
Received: from eggs.gnu.org ([209.51.188.92]:56440)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1nxPsl-00083a-Hd
 for 55645 <at> debbugs.gnu.org; Sat, 04 Jun 2022 05:15:47 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47586)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1nxPsf-0000PO-Si; Sat, 04 Jun 2022 05:15:37 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=jRIwfGna4w9t/pRlU9KnKTMn1DmX09gWLuLnRB7tQzk=; b=Iw7WV32wKLW/
 ob9W2RadvwOGlxRFR9M6oz0hm03B0L65e12qOutihVFEGsEhohGu9xNbTHbuicQadS7jGVp97CbRL
 pQ/KJGr2jfcb2i95+iegah35SRTlMo3HyXDUT8EumWGPJGXH74jnZc0Swbc6/5uLjIwznb3aoTNH5
 w9wsTgis7tZeWGeQQrKLKKvU/iUnCtX1aFzN3igRG0hyNVGbyDgzkaqhydLpAlhkUOsPIWeUgswff
 r/GrGCxk7rlmwaTtCjtsrJzdOpUajp2yK9r+bQi2vU0QQ5H3Do5KrgJ0lcjS9dDGn5HP//thjuQmM
 xdt9HnGM2TFQrK0+mrTs9Q==;
Received: from [87.69.77.57] (port=4506 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1nxPsa-0007m4-LS; Sat, 04 Jun 2022 05:15:34 -0400
Date: Sat, 04 Jun 2022 12:15:26 +0300
Message-Id: <83czfobxht.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Tom Gillespie <tgbugs@HIDDEN>
In-Reply-To: <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
 (message from Tom Gillespie on Sun, 29 May 2022 14:03:11 -0700)
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
 <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: larsi@HIDDEN, 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Tom Gillespie <tgbugs@HIDDEN>
> Date: Sun, 29 May 2022 14:03:11 -0700
> Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 55645 <at> debbugs.gnu.org
> 
> Hi Eli,
>   I have included an example below, with some additional context. Best!
> Tom

OK, thanks (and sorry for the delay in responding).  I think I
understand the issue now.

You say in your OP that there's no way to work around the issue, but I
wonder if this is really so.  It seems to me that by adding a
backslash before '.' and '?', before computing the hash, would be one
workaround?

> The example below works on emacs-18 (had to remove the number 1.0
> example because emacs 18 does not have support for reading floats).
> 
> The output of this code is unchanged from emacs-18 through emacs-28,
> however it is now different in emacs-29.
> Emacs 18-28:
> "(progn (+ 1 2) (a b\\.c d) (defun hello nil world)) (progn (some
> elisp code I want to normalize\\. That has strings \"1.0\" and symbols
> a\\.b))"
> Emacs 29:
> "(progn (+ 1 2) (a b.c d) (defun hello nil world)) (progn (some elisp
> code I want to normalize. That has strings \"1.0\" and symbols a.b))"
> 
> #+begin_src elisp :tangle /tmp/example.el
> (defun normalize-elisp-code (body)
>   (let (print-quoted print-length print-level) ; proposed variable
> would be added here
>     (prin1-to-string (read (concat "(progn\n" body "\n)")))))
> 
> (defvar example-body-1 "(+ 1 2) (a b\\.c d) (defun hello () world)")
> (defvar example-body-2 (prin1-to-string '(some elisp code I want to
> normalize\. That has strings "1.0" and symbols a\.b)))
> (message "%s %s"
>          (normalize-elisp-code example-body-1)
>          (normalize-elisp-code example-body-2))
> #+end_src
> 
> The additional step in my use case is the checksum, which cannot be
> read back in, and changes from 28 -> 29 due to the differences in the
> output of prin1-to-string seen above.
> 
> #+begin_src elisp
> (defun checksum-elisp-code (body)
>   (secure-hash 'sha256 (normalize-elisp-code body)))
> 
> (message "%s %s"
>          (checksum-elisp-code example-body-1)
>          (checksum-elisp-code example-body-2))
> #+end_src

Frankly, I'm amazed that someone could have such faith into
immutability of Emacs Lisp.  Why would you assume that the above
produces the same literal string across versions, especially given
everything that happens lately in Emacs, including changes in the
byte-compiler, the introduction of native-compilation, etc.  If
someone would show me a design that is based on this, I'd tell them
they place their bet on a dubious horse, and suggest to find a better
design.  To me, this is taking some Emacs feature that just happened
to be stable, and assuming it will forever be stable.  There's no
reason and no real basis for such assumptions.

Thus, I agree with Lars that it is strange to hear that prin1 is used
as something that's supposed to produce a canonical representation of
Lisp code; it's definitely isn't its purpose.

Anyway, one way forward is to add a new API specifically for that
purpose, and then guarantee that the output of that new API will be
stable.  This will also take care of the issue with the design that
relies on prin1.

Another way forward is to revert the change.  And here I'm asking Lars
what are the reasons for the change, except some aesthetics-related
considerations, whereby we basically didn't see why the escapes are
needed.  If the only problems are that we didn't see a good reason for
keeping the escapes, perhaps now we do have a good reason?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 29 May 2022 21:03:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 29 17:03:29 2022
Received: from localhost ([127.0.0.1]:42033 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nvQ4P-0008Rz-Gx
	for submit <at> debbugs.gnu.org; Sun, 29 May 2022 17:03:29 -0400
Received: from mail-yb1-f172.google.com ([209.85.219.172]:44578)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <tgbugs@HIDDEN>) id 1nvQ4O-0008Rn-MY
 for 55645 <at> debbugs.gnu.org; Sun, 29 May 2022 17:03:29 -0400
Received: by mail-yb1-f172.google.com with SMTP id a64so5921314ybg.11
 for <55645 <at> debbugs.gnu.org>; Sun, 29 May 2022 14:03:28 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=wC3S8v4gidIBBvRFXeomFTlCS69Y09Mhi5FjsxopoF4=;
 b=MLTG440KIWgHwfTJJCkyNzhGdZmfo5IMRoSVyqzq4TCweRrd7jsl1+lKnlCV+mAkQy
 k0Yx/Ox8W//9iZv1pdNTgDArLcv2HHQT2I7jLU0uSve32vaqegw4bAO8K0PygCDgU8qm
 Ki9cvY0K4CvOnlDeZwwfnd6GXEKyGUmNCijhGs7NCWIJIjSt9Zmyz5LGR6ziPl3jyVrV
 E9ZATWJLNj5RdLeGG1UlApeFFq5zrRjIdWK72tenTfcrXKCCzLGhvZJ2/VotcT3wW6gb
 lW06whjKcEajh1PVZ2kvmIPU6I4ZpPuEuGqH+i2wSP5X0mhr7tjHAmzL7kZF8EXPSbDZ
 DAdA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=wC3S8v4gidIBBvRFXeomFTlCS69Y09Mhi5FjsxopoF4=;
 b=V29WhKUp8k6Obr/VUuC+4D6w8hc2eE9psrEl9fOz/grPEfvK1q6oB6LWQM6w2Bn+hD
 RB3e5WcjWrRTxcwgzB9uKqg1Q6+A4xBhs0VujC1VwF2LnOQZeQh+WVCyGaaVGUnacSfJ
 N93ufeWV7nApYec6qS0q5TbC4/jwhJ50fia0anBtHSK9MBMjWRxa50ZZV7tB9TETlcg5
 Ovlkgqum0OCo2DGfNWrqKVnhDzNwI35tnWSJhgd4mhsc2UhsrvSzl92jPQarslHkbZ0D
 WxnetAfgWYVeCxtobGfosNsB1MoSS5GFiDJ8EJ8Hec46YfYZWwe25zH+cTmSQLpAEe6w
 97nA==
X-Gm-Message-State: AOAM530+68XvvsSrmQlbcjnnSOKHGgq3ne0o4rSTmsIuPv/EdOkG9+a4
 mHH/tjNmn9iA8pzcCvTyWz4iqpscw+dtP9/ahwE=
X-Google-Smtp-Source: ABdhPJwlUMFRqqbrruchFWCvcjkZFQHJTogmyrfVwbj4BvkW2ffZl2Rxf8qBqYfQOo5ZTF98tV/UgY6dVgkCgSarTRU=
X-Received: by 2002:a25:af4e:0:b0:655:c9a3:affb with SMTP id
 c14-20020a25af4e000000b00655c9a3affbmr21374994ybj.360.1653858202812; Sun, 29
 May 2022 14:03:22 -0700 (PDT)
MIME-Version: 1.0
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 <87o7zg1nut.fsf@HIDDEN> <83v8tojrr5.fsf@HIDDEN>
In-Reply-To: <83v8tojrr5.fsf@HIDDEN>
From: Tom Gillespie <tgbugs@HIDDEN>
Date: Sun, 29 May 2022 14:03:11 -0700
Message-ID: <CA+G3_PNrEEZmV+ECGG9Ukp4MpRBT4WxBhujudM5TcsG3Axr6FQ@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 55645
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Eli,
  I have included an example below, with some additional context. Best!
Tom

I'm using my own use case as an example, but I suspect that there are
other users out there who may have similar use cases where stability
of the printed representation of read code is important.

Some examples from a quick search on github that will or could be
affected by this (beyond my own). I only searched for cases matching
my own involving secure-hash and prin1-to-string, but there are surely
other cases that would be affected that I have not imagined.
https://github.com/skeeto/elfeed/blob/162d7d545ed41c27967d108c04aa31f5a61c8e16/web/elfeed-web.el#L73-L75
https://github.com/mrmekon/snitch-el/blob/3b3e7f1bf612c4624764d1ec4b1a96e4d2850b05/snitch-timer.el#L164-L181
https://github.com/radian-software/straight.el/blob/af5437f2afd00936c883124d6d3098721c2d306c/straight.el#L5627

https://github.com/search?q=prin1-to-string+secure-hash&type=Code
You can filter out some of the noise by adding the follow to the search
-elfeed -orgstrap -quelpa -litable -xah-elisp-mode -subr.el

The use case that I have is to store the checksum of a code block to
make sure that it has not changed. The checksum needs to be invariant
to changes in formatting e.g. whitespace and needs to be backward and
forward compatible across Emacs versions. In order to compute the
checksum I need a serialized representation of the code. Note when I
say "compare" two pieces of elisp code, one of them may no longer be
available to be read, because only a checksum was retained, so direct
comparison of the two structures in memory is not possible and defeats
the point of having something that is simple to audit and store.

This is discussed in more detail in the orgstrap readme.
https://github.com/tgbugs/orgstrap/blob/master/README.org#normalization-functions
https://github.com/tgbugs/orgstrap/blob/master/README.org#specification

From Emacs 18 through 28 prin1-to-string and the existing print
variables have been able to provide the needed stability.

There is currently no way to compensate for the change introduced in
637dde4aba921435f78d0de769ad74c4f3230aa6 short of reimplementing the
old behavior of prin1-to-string from scratch, which would ultimately
increase the maintenance load across the whole community.

The example below works on emacs-18 (had to remove the number 1.0
example because emacs 18 does not have support for reading floats).

The output of this code is unchanged from emacs-18 through emacs-28,
however it is now different in emacs-29.
Emacs 18-28:
"(progn (+ 1 2) (a b\\.c d) (defun hello nil world)) (progn (some
elisp code I want to normalize\\. That has strings \"1.0\" and symbols
a\\.b))"
Emacs 29:
"(progn (+ 1 2) (a b.c d) (defun hello nil world)) (progn (some elisp
code I want to normalize. That has strings \"1.0\" and symbols a.b))"

#+begin_src elisp :tangle /tmp/example.el
(defun normalize-elisp-code (body)
  (let (print-quoted print-length print-level) ; proposed variable
would be added here
    (prin1-to-string (read (concat "(progn\n" body "\n)")))))

(defvar example-body-1 "(+ 1 2) (a b\\.c d) (defun hello () world)")
(defvar example-body-2 (prin1-to-string '(some elisp code I want to
normalize\. That has strings "1.0" and symbols a\.b)))
(message "%s %s"
         (normalize-elisp-code example-body-1)
         (normalize-elisp-code example-body-2))
#+end_src

The additional step in my use case is the checksum, which cannot be
read back in, and changes from 28 -> 29 due to the differences in the
output of prin1-to-string seen above.

#+begin_src elisp
(defun checksum-elisp-code (body)
  (secure-hash 'sha256 (normalize-elisp-code body)))

(message "%s %s"
         (checksum-elisp-code example-body-1)
         (checksum-elisp-code example-body-2))
#+end_src




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 29 May 2022 15:14:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 29 11:14:17 2022
Received: from localhost ([127.0.0.1]:41613 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nvKcT-0004RK-Fd
	for submit <at> debbugs.gnu.org; Sun, 29 May 2022 11:14:17 -0400
Received: from eggs.gnu.org ([209.51.188.92]:33776)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1nvKcP-0004R3-C9
 for 55645 <at> debbugs.gnu.org; Sun, 29 May 2022 11:14:15 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47428)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1nvKcJ-00076v-R1; Sun, 29 May 2022 11:14:07 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=1OO3sgBLd7O4SAa7egiVGEkZU7kqi6m4omIKZjpID7c=; b=EQjDNnMpEHp2
 WLwdUeiUj26VsCPeIfv7iV3F8mBjQwarW+8G0bJ31SAedPHpnUy2W9BLQWreEYx1u4kIYa+TEKbIx
 BRFcaX2RAe7lIeclq7sWnGx8uvjhffAQWa1hcB+u32vBRJTEMjcJwM8k1NoKUnkTqh48cl86MZ1rL
 0YDRNvAQP4JQH4KtRqJ/GtpD914wvUaVhzGnqcxsHMbZoxJgH1fdfFt5X6c7tnLcBovZH81zedZsj
 x46gl9q6T/ZnNTP2ylv6c98iobzZI2xQhwZeKAsLHdO3uuaqDa1saBrnFLj8FsaevwGtXSUyZEVFh
 OU/y+Lis/wcNZyDh6mORUw==;
Received: from [87.69.77.57] (port=1747 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1nvKcJ-0001e4-Ay; Sun, 29 May 2022 11:14:07 -0400
Date: Sun, 29 May 2022 18:14:06 +0300
Message-Id: <83v8tojrr5.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87o7zg1nut.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sun, 
 29 May 2022 15:15:38 +0200)
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN> 
 <87o7zg1nut.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: tgbugs@HIDDEN, 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 55645 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>
> Date: Sun, 29 May 2022 15:15:38 +0200
> 
> Tom Gillespie <tgbugs@HIDDEN> writes:
> 
> > Ah I think I know what is missing here. I'm not trying to compare arbitrary
> > elisp objects. I'm explicitly only trying to compare literal emacs lisp source
> > code and that has been extremely easy since at least emacs 24 (iirc it is
> > also the same in 23). The only issue I have encountered was a change in
> > iirc 27 of the default value for print-escape-newlines or something like that.
> 
> I'm just not convinced that there's a compelling use case here that
> would support the added maintenance burden of adding Yet Another
> Printing Variable here -- you're using prin1 to implement something that
> prin1 was never meant to support.  If you want to see whether some code
> is "the same", then I think you really have to read the forms in and
> compare the forms.
> 
> But perhaps Eli has an opinion; added to the CCs.

I think I'd need an example that demonstrates the issue, to make up my
mind.  Tom, can you describe the issue in more detail, and provide an
example or two?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 29 May 2022 13:15:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 29 09:15:52 2022
Received: from localhost ([127.0.0.1]:39641 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nvIlr-0001S7-Im
	for submit <at> debbugs.gnu.org; Sun, 29 May 2022 09:15:51 -0400
Received: from quimby.gnus.org ([95.216.78.240]:33332)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nvIlp-0001KE-KG
 for 55645 <at> debbugs.gnu.org; Sun, 29 May 2022 09:15:50 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=1hEoMPCOgiE2/Ryo2LzGDbVHeVJ6TQn1lSJCDe7jFiA=; b=Feb8wy7phRzxyBqh6vVTkLqehR
 aSI22cVM7Kyx1KqeP0WDSxpLKcUvS7ELMKAeqnXbsg4GoIG520GIT2AmVutToLP3Xvc9cKhV9qoAu
 ih9FWjPQQgfzRe9hQ5U9xaMxawrRu5dUqbXrOtBMcYwwz5CFgolv1b7p/PhkjZeu9w/A=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nvIlg-0004Hf-Qa; Sun, 29 May 2022 15:15:43 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Tom Gillespie <tgbugs@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
 <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAD1BMVEV0L1p1PGCOV3rT
 yM/////+RlXKAAAAAWJLR0QEj2jZUQAAAAd0SU1FB+YFHQw7E9dMBY8AAAGnSURBVDjLbZTbgcQg
 CEXBaQCcBgQbmEj/ve3FPHR2l6+Yw0VeCRGRqrLW3lw6GTH38AiKaU3VdchgJSoRowf5NIBajIdV
 IXrFgALGqqYqbyvjA9Dh+IRCDHEt3pyk9xkKvhUuSEC01uZ6eE9XKDyfcAkhWuvFzzdXqPhoWpVR
 3N5xAFCd4NDTzKnUaEuB29O4qfeBzB4QuByZMUv119hBUyGUjfqqtx1kN8CSsO8gMlR2E62obQeH
 izLCpcx3EC50G9cdDNWHYDILRCO5RbhqA+58K/QLpOYS2C8waFmGWMSQatMLjLIUfueXoZr2+GNO
 cWCn/gf6j2IYIZNvMO85AX8BSz//q8BcsSiuCWgCfyrBDNHpbENm5XYK2gNMuFh3k/4M5QRYY2G3
 M+kx+94dwshxSm7hfUPeiXQHZiA+T3mcTe/pccxBRi62ne9nkkaZhbzvEtLKmGAeXld188A+mzjt
 vY+2bOC1qs4qFsgZIsdz5XQDnE11VL/24HyqyBcf6LYg17704YYG3aA/oMzJuf0GPH8bQPT4jeWy
 BJkLAMv9SY+2KX4A1oiDSpoAjkYAAAAldEVYdGRhdGU6Y3JlYXRlADIwMjItMDUtMjlUMTI6NTk6
 MTkrMDA6MDA8IiopAAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIyLTA1LTI5VDEyOjU5OjE5KzAwOjAw
 TX+SlQAAAABJRU5ErkJggg==
X-Now-Playing: The Smiths's _The Smiths_: "The Hand That Rocks The Cradle"
Date: Sun, 29 May 2022 15:15:38 +0200
In-Reply-To: <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
 (Tom Gillespie's message of "Sat, 28 May 2022 10:54:25 -0700")
Message-ID: <87o7zg1nut.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Tom Gillespie <tgbugs@HIDDEN> writes: > Ah I think I know
 what is missing here. I'm not trying to compare arbitrary > elisp objects.
 I'm explicitly only trying to compare literal emacs lisp source > code and
 that has been extremely easy s [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: Eli Zaretskii <eliz@HIDDEN>, 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Tom Gillespie <tgbugs@HIDDEN> writes:

> Ah I think I know what is missing here. I'm not trying to compare arbitrary
> elisp objects. I'm explicitly only trying to compare literal emacs lisp source
> code and that has been extremely easy since at least emacs 24 (iirc it is
> also the same in 23). The only issue I have encountered was a change in
> iirc 27 of the default value for print-escape-newlines or something like that.

I'm just not convinced that there's a compelling use case here that
would support the added maintenance burden of adding Yet Another
Printing Variable here -- you're using prin1 to implement something that
prin1 was never meant to support.  If you want to see whether some code
is "the same", then I think you really have to read the forms in and
compare the forms.

But perhaps Eli has an opinion; added to the CCs.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 28 May 2022 23:14:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 28 19:14:39 2022
Received: from localhost ([127.0.0.1]:39056 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nv5de-0002MF-DY
	for submit <at> debbugs.gnu.org; Sat, 28 May 2022 19:14:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:59868)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rms@HIDDEN>) id 1nv5dd-0002M3-8Z
 for 55645 <at> debbugs.gnu.org; Sat, 28 May 2022 19:14:29 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:37082)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rms@HIDDEN>)
 id 1nv5dY-0006RH-0W; Sat, 28 May 2022 19:14:24 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=Date:References:Subject:In-Reply-To:To:From:
 mime-version; bh=EbeU1GyJJsN41/eb9S1z2RFlgy5Tq8pFQoOKiQmhQZc=; b=lXqlHeY0zjye
 QqaunwDFhkgQ9EM4IWIYgH42i2yhiNkcWlxDGa9YKciJoXhDUZfaB/7AMQ0lCRjJHQEPnJRsssNzI
 ra4bl4c9tUpoF3ab6ohA3tFVT3b74emI4BFmDteNfAWM1i0q6d7psHugC/IXuDqMpwOFr82G+Bwiq
 4yBFxjAQMxhxVTSyVTrahxOBOzG7crO4s9/6o4tBANBQIl01itjTVxZtS/zh+m9L54K4vAkIoQTJD
 tFEgGh2U6YZzMClN4hDKQ+Pi4FnUp40ZJmXqvVk0wK/0bbaurEtvwLj9DJ6yQknP6oLTFvsXAWIsd
 1crIOFhAHcc2ZUyJckuDpg==;
Received: from rms by fencepost.gnu.org with local (Exim 4.90_1)
 (envelope-from <rms@HIDDEN>)
 id 1nv5dP-0006p0-9T; Sat, 28 May 2022 19:14:15 -0400
Content-Type: text/plain; charset=Utf-8
From: Richard Stallman <rms@HIDDEN>
To: Tom Gillespie <tgbugs@HIDDEN>
In-Reply-To: <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 (message from Tom Gillespie on Fri, 27 May 2022 12:19:27 -0700)
Subject: Re: bug#55645: src/print.c;
 print_object changes make it impossible to compare elisp code across
 versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
Message-Id: <E1nv5dP-0006p0-9T@HIDDEN>
Date: Sat, 28 May 2022 19:14:15 -0400
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: larsi@HIDDEN, 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: rms@HIDDEN
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

[[[ To any NSA and FBI agents reading my email: please consider    ]]]
[[[ whether defending the US Constitution against all enemies,     ]]]
[[[ foreign or domestic, requires you to follow Snowden's example. ]]]

  > I was thinking the same. I realize that for many objects where
  > there is no guarantee of homoiconicity the prin1 representation
  > definitely changes all the time. However, I think that symbols
  > fall into a more homoiconic category (namely the category
  > of objects that can appear literally in code).

I agree.

We have no absolute rule against changing the print syntax of symbols,
but we see that it this change is likely to cause a real practical
disadvantage for some users.  We should treat that as a significant
problem, and do what it takes to spare users that practical problem.

-- 
Dr Richard Stallman (https://stallman.org)
Chief GNUisance of the GNU Project (https://gnu.org)
Founder, Free Software Foundation (https://fsf.org)
Internet Hall-of-Famer (https://internethalloffame.org)






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 28 May 2022 17:54:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 28 13:54:44 2022
Received: from localhost ([127.0.0.1]:38864 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nv0eC-00031P-2s
	for submit <at> debbugs.gnu.org; Sat, 28 May 2022 13:54:44 -0400
Received: from mail-yw1-f172.google.com ([209.85.128.172]:42715)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <tgbugs@HIDDEN>) id 1nv0eA-00031D-I2
 for 55645 <at> debbugs.gnu.org; Sat, 28 May 2022 13:54:42 -0400
Received: by mail-yw1-f172.google.com with SMTP id
 00721157ae682-2ef5380669cso75263307b3.9
 for <55645 <at> debbugs.gnu.org>; Sat, 28 May 2022 10:54:42 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=GYY8vyhOCZZAKWTF8h20p2i/qxstgi4ljecF2ogeu4E=;
 b=T0AOeXJvblcmLWPLgCkESxIUqq4V1L0j208bXTipUFNVURfIrrUBXF90CviW01cU33
 HYy2cTBIWkbtH3ftZdqjN6cb9xDWbXL5jt32xcHuGudLktA9/psz3OpeageZbjFind//
 AZzKMqxHwb2pJJM20tPQVg61o7SVMRFA4m9GHO0XqUofA1EvE5tD8+mCQwY2pNKRnU6P
 DYKzofg1HPRvxvhZKcjSp+ONXFt1E2frCovgkDBnIsDUeGlvtBgxjjXjJ8McTtquJkE3
 SkNMUCG1vR0xN+/Rnz1GzpQ5qi91fhTvdmKyop7M4RQT6AcskRTR8fAIA3tf7cPuAv+X
 Qe2Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=GYY8vyhOCZZAKWTF8h20p2i/qxstgi4ljecF2ogeu4E=;
 b=O6pmCW9F88jhVOcO9sNouZ+H/AIurp5JNe04QPGinlTilePGJh7Ougw2sc5WcsXlo+
 8ALhe75LB2aT+p8hf2abkuBKHJMxymdSJWxSmJwKMA/NxiZYh4t7I/KHnaxFP4LpLXvN
 iAX2PmwCO5VuBQ+tuxI5AaABgfggPRzS1/8mapnG5TtYPG8b3w3g8ube7Ak6VNcnDGJ/
 iZhH0Aua3W9zVlAlm/rJnw+/seF8LoDN1g98jNCAMDXhK3vLOVtqQSXB1tOZP+tM7g6v
 yp3rwXfrvkrSsQEqj79AaDb8VxEnl2dlRVBDgvaEx18RRLaUABHdZJFqI4M3nU5yzG2l
 jhvQ==
X-Gm-Message-State: AOAM530TjhPfaIRHi1cNb5MoaGqzLo64PFzcyENF8AGc2PvABmd59HK4
 CuM2X2uzXPE47N9uzCJIi3J3pDhubXb15GBIPV0=
X-Google-Smtp-Source: ABdhPJx4dFptHept/icvz77+Rzf/DpKksYfHsTaNExkg5mqneCP2FDd20bMKbgQUGMeW+hSjZwHYKsoRzE1STHaADV0=
X-Received: by 2002:a05:690c:97:b0:2f1:9582:6685 with SMTP id
 be23-20020a05690c009700b002f195826685mr52074663ywb.395.1653760476768; Sat, 28
 May 2022 10:54:36 -0700 (PDT)
MIME-Version: 1.0
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 <874k1a54ap.fsf@HIDDEN>
In-Reply-To: <874k1a54ap.fsf@HIDDEN>
From: Tom Gillespie <tgbugs@HIDDEN>
Date: Sat, 28 May 2022 10:54:25 -0700
Message-ID: <CA+G3_POTj7JP+ksSyZFAy5jT-T+KFuVfRYCTNZuPGbPjh4OLMg@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
To: Lars Ingebrigtsen <larsi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 55645
Cc: 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> If you're using prin1 as a way to compare stably differences between
> objects, this only works by accident: You have to be very lucky in which
> objects you have included in the output so far if you've managed to make
> this code work over time.

Ah I think I know what is missing here. I'm not trying to compare arbitrary
elisp objects. I'm explicitly only trying to compare literal emacs lisp source
code and that has been extremely easy since at least emacs 24 (iirc it is
also the same in 23). The only issue I have encountered was a change in
iirc 27 of the default value for print-escape-newlines or something like that.

> We can indeed add something that lets you control how symbols in
> specific are output by prin1, but I don't really see the utility in
> general -- because we have changed, and will change, how other objects
> are output by prin1, and if the objects you're outputting happens to
> contain these, your algo will break again.

These aren't arbitrary elisp objects, they are only objects that appear in
quoted elisp source code. There has been exactly one change in that
since emacs 24 (and possibly before), and it was a change where there
was already a variable to control the behavior.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 28 May 2022 10:40:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 28 06:40:15 2022
Received: from localhost ([127.0.0.1]:36455 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nutrj-0001rw-8f
	for submit <at> debbugs.gnu.org; Sat, 28 May 2022 06:40:15 -0400
Received: from quimby.gnus.org ([95.216.78.240]:50338)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nutrf-0001ra-Ba
 for 55645 <at> debbugs.gnu.org; Sat, 28 May 2022 06:40:13 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=EJQ3NkpC26TRGKDJzANo9HVIWIePwZsu+8w+tiJNqnw=; b=hmBhyesn86ceCWtj54QeU0xcwT
 sahXaruG8pYZIY1oXulHYUgFzRuRxecHLEDmPloHx+vI678UANvG2sLmHwWFqim57Dh8NfGGtcglG
 kxPO3mpGdEM4w9QjOxlDZ8q7sx8kFpmAfijpPjPCCBxwC5xFCXs9qOw9soVETTGnReZk=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nutrW-0002YB-BJ; Sat, 28 May 2022 12:40:04 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Tom Gillespie <tgbugs@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
 <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAElBMVEXjt9O6bZgnLq2X
 TGZEJTf////hBHywAAAAAWJLR0QF+G/pxwAAAAd0SU1FB+YFHAofOUEuNigAAAG7SURBVDjLdZLr
 dcMgDIXB7gDIMEBLO0BUaYA4Yv+ZqgdxfNKEH20On++VdEVKz6fklPtnT/9P1vscoMRFSgDF/6fk
 gBCgUqVB0hDiIwOr0NDDIjxoR1Ns/QzYgODDapU2QsKjXq2GCgxk+e2hGMJa/aQA4jHsekgNqxyK
 ak4iWBVYv31a2fdGBjm4W5UVml4G2FkVsFgkOa1qMdSeSIEoWLzGBKagqnwG5l0hu9Eg+8ADgbJp
 gJliQAUsLblViq5aNGVzgCacS8yRToAyYUmHwmuI1RDwrvrndiouqtxtHUvvX6b4QD7aBYxuNwcy
 YnLS5N1qZvUxk0JilcT+FwczRMIKDJdHug3nBgmAy+VhtdIdYMZ8jdqPrHQ8fUXf+RoPa/N2XaGZ
 V6C13BVYayj05UAdvloA6Ek9ArAUaMzgVhqiXlA8uIGlNTmsbGI2CWlxapGtpWtXJP5XuyVUg8sB
 wCYxkL2Rq81uYOAcvGpDwwEE2CMqBTXrr5vuY5tASGgHCLDfawxfiCIoPBWzRixkpxoP5gmohGMx
 N518O4Hj3Ervr8GT1QnAG1CWvpzBntvPayvRuwP0N+ct+AOuNaunVkLiqAAAACV0RVh0ZGF0ZTpj
 cmVhdGUAMjAyMi0wNS0yOFQxMDozMTo1NyswMDowMN0B8eMAAAAldEVYdGRhdGU6bW9kaWZ5ADIw
 MjItMDUtMjhUMTA6MzE6NTcrMDA6MDCsXElfAAAAAElFTkSuQmCC
X-Now-Playing: Snapped Ankles's _Forest of Your Problems_: "Forest of Your
 Problems"
Date: Sat, 28 May 2022 12:39:58 +0200
In-Reply-To: <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
 (Tom Gillespie's message of "Fri, 27 May 2022 12:19:27 -0700")
Message-ID: <874k1a54ap.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Tom Gillespie <tgbugs@HIDDEN> writes: > That being said, 
 I think this is be the first time in the history > of emacs that prin1 for
 symbols has changed, so having a > way to preserve the old behavior for things
 that depend on it > would b [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Tom Gillespie <tgbugs@HIDDEN> writes:

> That being said, I think this is be the first time in the history
> of emacs that prin1 for symbols has changed, so having a
> way to preserve the old behavior for things that depend on it
> would be greatly appreciated.

That's makes sense, but:

>> prin1?  Stable for 30 years?  Nope.  (But some objects have had a stable
>> printed representation that long, I'm sure.)
>
> Er, indeed, I was being overly general, I meant symbols specifically.

If you're using prin1 as a way to compare stably differences between
objects, this only works by accident: You have to be very lucky in which
objects you have included in the output so far if you've managed to make
this code work over time.

We can indeed add something that lets you control how symbols in
specific are output by prin1, but I don't really see the utility in
general -- because we have changed, and will change, how other objects
are output by prin1, and if the objects you're outputting happens to
contain these, your algo will break again.

So I think this is one of those "don't do that" things, unfortunately.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 27 May 2022 19:19:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri May 27 15:19:46 2022
Received: from localhost ([127.0.0.1]:35810 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nufUw-0005t2-4e
	for submit <at> debbugs.gnu.org; Fri, 27 May 2022 15:19:46 -0400
Received: from mail-yw1-f171.google.com ([209.85.128.171]:33391)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <tgbugs@HIDDEN>) id 1nufUt-0005sp-Oz
 for 55645 <at> debbugs.gnu.org; Fri, 27 May 2022 15:19:44 -0400
Received: by mail-yw1-f171.google.com with SMTP id
 00721157ae682-300312ba5e2so57751707b3.0
 for <55645 <at> debbugs.gnu.org>; Fri, 27 May 2022 12:19:43 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=lP0aK9wJtLGB4Us1gXDUn2nZpjYj4VXHzV5vsqEqU+I=;
 b=LYaPJtD5PyHPirb9yYVRJGYG50+g8Ra3Mc+aJ5mLsgDoeoBU9r9pTDNqVoT6wCZjPd
 FR9uMF917KX22Bw5+vZwwJLvf995ff7CjiUE2Ljyfg9N9k/Wt8W4gCxPyStTKXBHBTVv
 H7Jfe8vt/yZ/igt+saSIgMF1jeeByupk4l3GDTIRZP+Vg0g8BDqMA4uJFKNv11GmZP2Y
 FamWi/J0GGS0g7a6jmSAsHxNBjl70XknkXdwby/Bp2BNyDFq28kMny3EPSDDxO4xjRaC
 npYT2pUP2aPz7G8kIM5V4TpV70MVxhy0qXgobmtpmJ6nqA1Rm6sTuGRbdycfMi9+QDAS
 UaCQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=lP0aK9wJtLGB4Us1gXDUn2nZpjYj4VXHzV5vsqEqU+I=;
 b=m6desaslCN4yIjVonS6GKBEouLt+UNBj/6UVIE1thObzeiUWoggsoe83NS9iMnHx8L
 gTM3i0VuRBXe7Kugb2fUdQIh3CE8I7VQNxvoQhrnOfKOBAYLz0br5yYJ/QNhW/MFWE0q
 tKBrHk4/N2L2FznaxvmE26mydWbS2AtYG0LVtyzIjVcaQME+RShHbpYzD1BiJD3LcE2z
 wgNpJDZ+yAl67Gg2z/hzMKJrjkTD/jbgIb4SrAjnIl5rd23BrO+4znvHURV7iQh2c5kc
 6LYUFXN7US9XKa9fJPNXn5Ovr8zOGsJmOWM3rBDqBjx7Bw3A6bliy+P2vQwkww0J8aKr
 s6Lw==
X-Gm-Message-State: AOAM530OJ9Z34c57BDu6X/wM5Ag/mphEbpdvL74m45bP81mDc+MKg7Yg
 RfWnsdTz+9euuMMORYMDRUs/m2FxcBCgKeKlhlE9ERSL
X-Google-Smtp-Source: ABdhPJxrJ27Y2e6nnFtC/t/lPcDdtEbWvwyAhXXG2zsmLH3seYzlBI6veWw4VUkSp/r78Cx3yd2YPy6NBTTLdjDeDiU=
X-Received: by 2002:a81:52d6:0:b0:309:ac63:3c80 with SMTP id
 g205-20020a8152d6000000b00309ac633c80mr2976308ywb.375.1653679178045; Fri, 27
 May 2022 12:19:38 -0700 (PDT)
MIME-Version: 1.0
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 <874k1b9ser.fsf@HIDDEN>
In-Reply-To: <874k1b9ser.fsf@HIDDEN>
From: Tom Gillespie <tgbugs@HIDDEN>
Date: Fri, 27 May 2022 12:19:27 -0700
Message-ID: <CA+G3_PN5Nx10+mAgt1VKA2Snfm34jHNSCiPS4BRY1s3w3LRWsA@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
To: Lars Ingebrigtsen <larsi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 55645
Cc: 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> but admittedly, these changes are usually for more obscure
> objects than symbols

I was thinking the same. I realize that for many objects where
there is no guarantee of homoiconicity the prin1 representation
definitely changes all the time. However, I think that symbols
fall into a more homoiconic category (namely the category
of objects that can appear literally in code).

Some time between emacs 18 and xemacs/22 the reader
DID change with regard to periods in symbols. In 18 you had
to escape the period or the reader throws a syntax error.

Thus your point about there being a mismatch between read
behavior and prin1 representation is accurate.

That being said, I think this is be the first time in the history
of emacs that prin1 for symbols has changed, so having a
way to preserve the old behavior for things that depend on it
would be greatly appreciated.

> prin1?  Stable for 30 years?  Nope.  (But some objects have had a stable
> printed representation that long, I'm sure.)

Er, indeed, I was being overly general, I meant symbols specifically.
I went back and checked in emacs-18 and this is what I get:

(prin1-to-string '(a b\.c d))
"(a b\\.c d)"
(emacs-version)
"GNU Emacs 18.59.1 of Sat Jul 31 2021 on localhost (linux)"




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 27 May 2022 10:33:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri May 27 06:33:29 2022
Received: from localhost ([127.0.0.1]:32819 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nuXHd-00064m-8T
	for submit <at> debbugs.gnu.org; Fri, 27 May 2022 06:33:29 -0400
Received: from quimby.gnus.org ([95.216.78.240]:38960)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nuXHa-00064X-Pt
 for 55645 <at> debbugs.gnu.org; Fri, 27 May 2022 06:33:28 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=mNbRchwlEqYdFWPoGxFZHXk8tMKKjP9lDdXle8qrdoA=; b=FsuAyrTIo7rO51TEdHICHEjFG7
 oBJ4OqATRZI5wJqDIbjuaQFV+VPdcdi0U7iyDAHskIWgonzzYiAWVau39teue98luafusVwRzdCdw
 4Au+OUDewohMkgZ54zYSxrUfid9gybTMiATxt5Yl+X7Cy65DJZ3q47A6RT5XNjoHW1OI=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nuXHS-0006tR-01; Fri, 27 May 2022 12:33:20 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Tom Gillespie <tgbugs@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
 <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAGFBMVEWvra3DurvTz86V
 kZOEe4BmX2c5NT/////DykhKAAAAAWJLR0QHFmGI6wAAAAd0SU1FB+YFGwoON2iYAIYAAAGbSURB
 VDjLddNLcoMwDABQEZeuDblA8QkcZLruNLBnasQFOuj+R6j8wUPSoJls/KyPsQPQmFfxAdC0JwBV
 pK79ByJ7PEEUyJYSmwQpmmPouKQmWokIJW6hXQGNxMybGP0ECEupip62VYhp7TPkUOQdRWqfYO0B
 nVRazBEsvJExGnJvs4+q0DqCsFPD5ZihEIZF2SquPWbowYNDC43sbZ8AFS2IVnI6Y3f4uk4ecUjH
 69p63uE7Ag7MfdNUV7+XeusT4LBaUEAtZqh7lQCVlJv6YT7CGAVX/q1nXeA6LWMWmi3YAlpKjIkA
 1b4O9fdHGHXEcB+EFgv8dOHD0peT69oQdSk1GxU3W3R3Gbovzb0JTdKlOxzm/YD1dulS/dTJl4zt
 ZlRKoWUkupfmPLedvKAciy0Z7CujMYvHqvTgzV5Ewsx3lJsMoOT3zuxtmx6DlRvs0nVH2O5hodHh
 SXcgjBmYMD2G/IqwAEt1qMI4cnR/BKb83V0Y7AgcjrBP/ADpb3CET36MAgpfBTzEP1AnGWelXq27
 s97DyboAnsAfc5uzr9+2q1YAAAAldEVYdGRhdGU6Y3JlYXRlADIwMjItMDUtMjdUMTA6MTQ6NTUr
 MDA6MDB6MfV1AAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIyLTA1LTI3VDEwOjE0OjU1KzAwOjAwC2xN
 yQAAAABJRU5ErkJggg==
X-Now-Playing: A. G. Cook's _7G (2): Guitar_: "Superstar (Live at Secret Sky)"
Date: Fri, 27 May 2022 12:33:16 +0200
In-Reply-To: <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
 (Tom Gillespie's message of "Thu, 26 May 2022 08:56:19 -0700")
Message-ID: <874k1b9ser.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Tom Gillespie <tgbugs@HIDDEN> writes: > If prin1 is not
 stable, is there a print that is expected to be stable? I don't think so.
 We tweak the Lisp printers from time to time (for instance, circular objects
 changed their representation the other day (again)), but admittedly, these
 changes are usually for more o [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Tom Gillespie <tgbugs@HIDDEN> writes:

> If prin1 is not stable, is there a print that is expected to be stable?

I don't think so.  We tweak the Lisp printers from time to time (for
instance, circular objects changed their representation the other day
(again)), but admittedly, these changes are usually for more obscure
objects than symbols.

> Whether it is meant to be stable or not it has been stable for at least
> 30 years.

prin1?  Stable for 30 years?  Nope.  (But some objects have had a stable
printed representation that long, I'm sure.)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 26 May 2022 15:56:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 26 11:56:45 2022
Received: from localhost ([127.0.0.1]:59831 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nuFqu-0002LD-RR
	for submit <at> debbugs.gnu.org; Thu, 26 May 2022 11:56:45 -0400
Received: from mail-yw1-f178.google.com ([209.85.128.178]:46443)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <tgbugs@HIDDEN>) id 1nuFqm-0002Ko-4p
 for 55645 <at> debbugs.gnu.org; Thu, 26 May 2022 11:56:43 -0400
Received: by mail-yw1-f178.google.com with SMTP id
 00721157ae682-300beab2b76so19741507b3.13
 for <55645 <at> debbugs.gnu.org>; Thu, 26 May 2022 08:56:36 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=VqT9L1+Zwtr7k409FTViAInRLIQJ3YcrzD/4NxObUdY=;
 b=n8yExMxKbU34EFbFm19RicXKlFK9r7RFgsI2/PBy2+S9jz4Qy9m29lQgLgFzVyGcIp
 SEtrUS8NlJgk/d0/+pJDHYGV+ZMftWWftputAI0EuS8dDR0UzfLxIIrJNcL9VLnXUcS9
 BEw67160JWvKx6IB1FCB5fxIVB+nGv/mR2TxsJBUdnlAo08QfkFmWp7s1n33uvOxphx4
 RHoAlvWFZEHgBZ2f5BVBTc2MP4riIS9vh9ZeGSX1d7NJjvfdHbKJxpC6a84DIDHf2D62
 +T4zJJioPfqrKT16R/FeFRvKeKkcChFrz2zBPDH3YrK1ZbKmOWPDUNbs0/+ADLdR9rHU
 aiUQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=VqT9L1+Zwtr7k409FTViAInRLIQJ3YcrzD/4NxObUdY=;
 b=c15A+fNgKHiJa1d0AYdKa0QrZu8IXhbHO8sM1L72GQx5SerwIXitBEy/9aLz2I4eef
 M5sd+kdp3H0jF4rIVS4at5xEtQzmNydT0AfewfL71VVdtwjkrCpuPqPTvbfH2hsZFt2p
 PPALpqhYEOwDAc40gvMcJZx1EpHD1FXWNl2jvc7e0TorGOyUp1514VnOaQjTyKvINhTF
 5pe2Uke2Sn6Phk3bqtJQQ8l/jkdYuVP2T/GNPgoWvzsn+/SECSSc156mfz3rfY5oKp8p
 bDdXzec+H0j63jUsdKGzysgn5U5zV0DJ2Q/9LyeBrE+7+9k7GigDMtkuQtZUc8Ov6UYX
 GKEw==
X-Gm-Message-State: AOAM5315QTmdS+BThMPo5TimxmU/ox8+5/MUeVGx2KfenQsAOH9+cpPc
 zqrYmLhQR6wA+LkGlUfcyz+ssp+GrHVfO9Qw/Pk=
X-Google-Smtp-Source: ABdhPJwzms9NB2JXIzcjklaxdybqC8loJejv85+syBHNylfowJuTBZZof1/cNo7PouafyYHgS302xyKc5Y0DK7u9gZk=
X-Received: by 2002:a81:ed4:0:b0:2f1:c8db:ce23 with SMTP id
 203-20020a810ed4000000b002f1c8dbce23mr38123306ywo.95.1653580590387; Thu, 26
 May 2022 08:56:30 -0700 (PDT)
MIME-Version: 1.0
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 <87zgj4biw7.fsf@HIDDEN>
In-Reply-To: <87zgj4biw7.fsf@HIDDEN>
From: Tom Gillespie <tgbugs@HIDDEN>
Date: Thu, 26 May 2022 08:56:19 -0700
Message-ID: <CA+G3_PN8yJe85geOjc8n6wAtDthzHL0M4JR9ECKAPzqwpTeLWg@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
To: Lars Ingebrigtsen <larsi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 55645
Cc: 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> prin1 has never guaranteed that the printed representation would be
> stable across versions, so if it's worked for you, that's by accident.

It may not be meant to be stable but this behavior is unchanged since
at least emacs-23, and given that xemacs has the same behavior, I'm
guessing that this behavior has been stable for nearly 30 years.

If prin1 is not stable, is there a print that is expected to be stable?

> It would be possible to add something to control this details (via the
> new OVERRIDES parameter), but it doesn't feel like it'd be worth it,
> because, well, the representation isn't meant to be stable.

Whether it is meant to be stable or not it has been stable for at least
30 years. If there is no print variant that does have stability guarantees
then I think we do need a dynamic variable that would have the old
behavior when it was nil, like those listed in Variables Affecting Output
https://www.gnu.org/software/emacs/manual/html_node/elisp/Output-Variables.html




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.
Added tag(s) moreinfo. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 55645 <at> debbugs.gnu.org:


Received: (at 55645) by debbugs.gnu.org; 26 May 2022 12:03:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 26 08:03:53 2022
Received: from localhost ([127.0.0.1]:57168 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nuCDY-0003th-QI
	for submit <at> debbugs.gnu.org; Thu, 26 May 2022 08:03:53 -0400
Received: from quimby.gnus.org ([95.216.78.240]:56536)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nuCDT-0003tI-1K
 for 55645 <at> debbugs.gnu.org; Thu, 26 May 2022 08:03:50 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=4xX2dpv8+s6UPt/hnh4ahYHEak0R5gWyXxnsfpmxGEA=; b=YC71xO6PFY6pqMPgeJPfxfvtD0
 itria0Kdkdj6Rapnk9DCqiLcqRsXY2bdmsP936MNAxU6+7WF50VwlpKjnSPlWyGnXlxHJfh2dShf0
 IcO6b8qUKhfSBVZDV6j3QtmMyGGEMsVpYvGphOuev6rgwb7iIM4JB+evy5iHPxu7UuEY=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nuCDK-0004Gk-Hb; Thu, 26 May 2022 14:03:40 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Tom Gillespie <tgbugs@HIDDEN>
Subject: Re: bug#55645: src/print.c; print_object changes make it impossible
 to compare elisp code across versions
References: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
X-Now-Playing: Talking Heads's _The Name Of This Band Is Talking Heads (Disc
 2: 1980-1981)_: "Stay Hungry"
Date: Thu, 26 May 2022 14:03:36 +0200
In-Reply-To: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
 (Tom Gillespie's message of "Wed, 25 May 2022 16:12:02 -0700")
Message-ID: <87zgj4biw7.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Tom Gillespie <tgbugs@HIDDEN> writes: > The changes made
 in 637dde4aba921435f78d0de769ad74c4f3230aa6 > make it impossible to use
 prin1-to-string
 as the basis for hashing elisp > code in a way that is independent of the
 emacs version. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 55645
Cc: 55645 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Tom Gillespie <tgbugs@HIDDEN> writes:

> The changes made in 637dde4aba921435f78d0de769ad74c4f3230aa6
> make it impossible to use prin1-to-string as the basis for hashing elisp
> code in a way that is independent of the emacs version.

prin1 has never guaranteed that the printed representation would be
stable across versions, so if it's worked for you, that's by accident.

> At the very least this change in behavior needs to be configurable so that
> the old behavior can be retained, preferably this change would be
> reverted entirely as it does not address the original bug (bug#23130) and
> is NOT low impact for users that actually use such functionality, whereas
> the change is completely invisible to those that do not use such functionality.

It would be possible to add something to control this details (via the
new OVERRIDES parameter), but it doesn't feel like it'd be worth it,
because, well, the representation isn't meant to be stable.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 25 May 2022 23:12:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 25 19:12:17 2022
Received: from localhost ([127.0.0.1]:56604 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nu0Ar-00032w-7q
	for submit <at> debbugs.gnu.org; Wed, 25 May 2022 19:12:17 -0400
Received: from lists.gnu.org ([209.51.188.17]:38768)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <tgbugs@HIDDEN>) id 1nu0Aq-00032o-2N
 for submit <at> debbugs.gnu.org; Wed, 25 May 2022 19:12:16 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:52518)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <tgbugs@HIDDEN>) id 1nu0Ap-0001sU-UW
 for bug-gnu-emacs@HIDDEN; Wed, 25 May 2022 19:12:15 -0400
Received: from mail-yb1-xb30.google.com ([2607:f8b0:4864:20::b30]:35601)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <tgbugs@HIDDEN>) id 1nu0Ao-00039F-E7
 for bug-gnu-emacs@HIDDEN; Wed, 25 May 2022 19:12:15 -0400
Received: by mail-yb1-xb30.google.com with SMTP id v26so292801ybd.2
 for <bug-gnu-emacs@HIDDEN>; Wed, 25 May 2022 16:12:13 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:from:date:message-id:subject:to;
 bh=7QkcxAyYwVeMW5JmNnj3K7lcu8BFWC10VHvKHO31NdY=;
 b=SM7oKL/PRHfO9l1DOko8fmE4XdluM3xWZfiWWmjXbBJuZ6vhfqAf5lO+XppDEycRxy
 yBh05YpMKYFx4zvP+HrdbcqWEhmhw3Cpl08Jk0A4iWdnTKbsyQ5WF/gGaY4hKXhar/wl
 pEwlD7nJFSEdBz+bLYe4dGiUQ6IdWbu9XrA9PTMh+mi9MWa9RcvjQXwY85z8xJFtryNC
 nosmhCwf0h1Iiv+8sByHZ78QQczSR9bZ/N3dSk1sisyXp2h9MRZ3lIFk4lT543luk6kL
 KJYTwujcLUwtlumlSb4j+bGrJBZ1x+X2MXUOJ+PFrZeEFG5Uv2WgFKx6Z+XOv+KZmxqn
 GLaQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to;
 bh=7QkcxAyYwVeMW5JmNnj3K7lcu8BFWC10VHvKHO31NdY=;
 b=Wzsm4lPx1diAis/nJnQq97Rk52i75OzVMAawnrzMrfkXexRUBIUJd3JZ/+k14/y+iU
 IovOYCtSuO0XO0cHkkIynm/K/zKBmEu+NZCN3Z41jBc78EH4Qg6mxv6Y4ph6KFjUYWqt
 4lAjykcRE7DBIrSgUGzN3vENWumA8wyk+ELT1NRR6VJ2OHNJ/KghQNJWqvWUUoh+Qsor
 YJWljWyZMdyKq6VkLy+qGgqf1FabUPnRprZ0cTZs+6j6/cJmQYn/Gi4IlvdtuKwFJquG
 nGbVOfupxgfLNhBWozaXS8oqVeqV9wisJaVHdNKTIxw5uxvad0uwWmtfk8zwyQuLHm+f
 ISLQ==
X-Gm-Message-State: AOAM531MJZWdD9UTFnxkzNSOBkjn1KxbkFY9hh4qRiIiUQ4z0Z8kpRKC
 Ulh8S/VXX9UWaS/mKEGwEluyLj8gWSx+TBthksoOXnJzyys=
X-Google-Smtp-Source: ABdhPJzGgosB5cWE4QZjn/C4knTDMgaZPOAYqNgq5qrTEm56NPe3uZlf3KJ+zNWcxAN+ZPN+daqhu9SnCpYJUm8qgqQ=
X-Received: by 2002:a25:af4e:0:b0:655:c9a3:affb with SMTP id
 c14-20020a25af4e000000b00655c9a3affbmr4495807ybj.360.1653520333037; Wed, 25
 May 2022 16:12:13 -0700 (PDT)
MIME-Version: 1.0
From: Tom Gillespie <tgbugs@HIDDEN>
Date: Wed, 25 May 2022 16:12:02 -0700
Message-ID: <CA+G3_PNrsSCwZM_C-0csv8ZJgYWwcgdbRoX_kuQK2UmThKN6+Q@HIDDEN>
Subject: src/print.c; print_object changes make it impossible to compare elisp
 code across versions
To: Emacs Bug Report <bug-gnu-emacs@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Received-SPF: pass client-ip=2607:f8b0:4864:20::b30;
 envelope-from=tgbugs@HIDDEN; helo=mail-yb1-xb30.google.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

The changes made in 637dde4aba921435f78d0de769ad74c4f3230aa6
make it impossible to use prin1-to-string as the basis for hashing elisp
code in a way that is independent of the emacs version.

The change completely breaks my orgstrap library across the 28 -> 29
boundary because the checksum computed on <= 28's prin1-to-string
and the checksum computed by 29's prin1-to-string no long match in
cases where there is a . or a ? in a symbol.

As implemented, there is no way to work around the issue, and I
suspect that many other users will be surprised and rather upset
by this change when they have the misfortune to encounter it.

At the very least this change in behavior needs to be configurable so that
the old behavior can be retained, preferably this change would be
reverted entirely as it does not address the original bug (bug#23130) and
is NOT low impact for users that actually use such functionality, whereas
the change is completely invisible to those that do not use such functionality.




Acknowledgement sent to Tom Gillespie <tgbugs@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#55645; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 7 Jun 2022 16:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.